// main.c
//
#define MAIN
#include "decls.h"

#define ELF_SIGNATURE 0x464C457F
#define ZIP_SIGNATURE 0x00000003

void decompress(void);
//void decode_elf(void);

#define SIGN_OFFSET          (0xFFFDFFF0 + 0x08)
#define NODE_ADDRESS          0xFFFFFFB0

extern void apctlGPIOInit(unsigned long dirMap);
extern int apctlGPIORead(int gpioNum);
extern int apctlGPIOWrite(int gpioNum, int state);

#define _REG(x) (*(volatile unsigned long *)(x))

int flag=0;

int main(void)
{
    unsigned int count;
    unsigned char * dbSign;
    unsigned char * ptr;
    unsigned char	Sdram_Size=0;

    ptr = (unsigned char *)NODE_ADDRESS;
    dbSign = (unsigned char *)SIGN_OFFSET;

    apctlGPIOInit(0xF320);
    
    //apctlGPIOWrite(12,1);
    //apctlGPIOWrite(11,1);
    apctlGPIOWrite(11,1); //power led
    
#if 0
    if(apctlGPIORead(5) == 0)
    {
    	flashbase = 0xffff6000;
    	flag = 1;
    	goto MODE;
    }
#endif
    
    count=0;
    while(1)
    {
    	if(apctlGPIORead(5) == 0)
    	{
    		count++;
    		if(count>=800000)
    		{
    			flashbase = 0xffff6000;
    			flag = 1;
    			goto MODE;
    		}
    	
        }
        else
        {
		break;
	}
	
    }
	
		
    
    if((memcmp (dbSign,"eRcOmM",6) == 0) )
    {
    	
    	if (memcmp(ptr,"\xff\xff\xff\xff\xff\xff",6) == 0)
    	{
    		flashbase = 0xffff3000;
    	}
    	else
    	{
    		flashbase = 0xfff00000;
    	}
    	
    }
    else
    {
    	flashbase = 0xffff6000;//download mode
    }


MODE:
    decompress();

}
