
typedef unsigned char BYTE;
typedef unsigned long  ULONG;
typedef unsigned short       uint16;

#define NULL ((void *)0)

#define HEAD 0
#define ADDRORDER 1
#define TAIL 2
typedef struct {
                   void * psNextIOB;
                   unsigned short dwLength;
                   unsigned short dwOffset;
                   unsigned char dbData[1600];
               }IOB;
typedef struct CBtype {
   void * psNextCB;             /* pointer to next CB */
} CB;

typedef struct CBQtype {
   void * psQHead;              /* pointer to Queue Head */
   void * psQTail;              /* pointer to Queue Tail */
   unsigned int dwQCount;               /* Queue's element count */
} CBQ;


int FreeIOB ( IOB * psIOB );
IOB * DriverGetIOB ( unsigned int dwSize );
void putCBToQ(CBQ *psCBQ,void * psCB,unsigned char dbOrder);
void * getCBFromQ(CBQ *psCBQ,unsigned int zeroSize);

