#include <stdio.h>
#include "wltypes.h"
#include "oem.h"
#include "IEEE_types.h"
#include "mib.h"
#include "api.h"
#include "uemf.h"
#include "wsIntrn.h"
#include "Mrvap.h"
#include "AspDef.h"
#include "qos.h"
#ifdef IEEE80211H
#include "domain.h"
#endif /* IEEE80211H */

#ifdef   VOIP_GUI
#include "hs_fwk_socket.h"
#include "hs_voip_sys.h"
#include "hs_voip_oam_if.h"
#endif

    #define BOOSTER_OFF  0
    #define BOOSTER_ON   1
    #define BOOSTER_AUTO 2
    
/* Antenna definitions. */
#define  AP_ANT_DIVERSITY       0x02 /* antenna mode  */
#define  AP_ANT_A               0x00 /* antenna mode  */
#define  AP_ANT_B               0x01 /* antenna mode  */
#define  RX_ANTENNA             0x00 /* which antenna */
#define  TX_ANTENNA             0x01 /* which antenna */
#ifdef FLEXMODE_TEST
//extern int NavOffset;
//extern int FlexModeBeacon;
extern UINT32 AGintOffset;
extern UINT8 AGinterval;
#endif /* FLEXMODE_TEST */
#ifdef IEEE80211H
extern UCHAR gSwitchChannel;
extern UCHAR bcn_reg_domain;
#endif
#define DECLARE_ASP(x) \
        static int x(int eid, webs_t wp, int argc, char_t **argv)
#define IMPLEMENT_ASP(x) DECLARE_ASP(x)
#define DECLARE_0_ASP_ARGS
#define DECLARE_1_ASP_ARGS                                         \
          char_t *arg1;                                            \
          if(ejArgs(argc, argv, T("%s %s"), &arg1) < 1) {          \
            websError(wp, 400, T("Insufficient args\n"));          \
            return -1;                                             \
          }
#define DECLARE_2_ASP_ARGS                                         \
          char_t *arg1, *arg2;                                     \
          if(ejArgs(argc, argv, T("%s %s"), &arg1, &arg2) < 2) {   \
            websError(wp, 400, T("Insufficient args\n"));          \
            return -1;                                             \
          }
#define DEFINE_ASP(x) \
		websAspDefine(T(#x), x);
//extern void GetSdkVersion(char *);
DECLARE_ASP(asp_channel_list1);
DECLARE_ASP(asp_channel_list2);
DECLARE_ASP(asp_channel_list3);
DECLARE_ASP(asp_AP_list);
DECLARE_ASP(asp_wds_mode);
DECLARE_ASP(asp_wds_bcast_mode);
DECLARE_ASP(asp_get_disable_assoc);
DECLARE_ASP(asp_ssid);
DECLARE_ASP(asp_firmware_version);
DECLARE_ASP(asp_bootcode_version);
DECLARE_ASP(asp_open_ssid_en_state);
DECLARE_ASP(asp_autolink);
DECLARE_ASP(asp_boostermode);
DECLARE_ASP(asp_boostermodestatus);
DECLARE_ASP(asp_filtermode);
DECLARE_ASP(asp_rf_preamble_option);
DECLARE_ASP(asp_tx_antenna_mode);
DECLARE_ASP(asp_rx_antenna_mode);
DECLARE_ASP(asp_antenna_mode);
DECLARE_ASP(asp_data_rate_b);
DECLARE_ASP(asp_data_rate_g);
DECLARE_ASP(asp_rf_channel);
DECLARE_ASP(asp_rf_autochannel);
DECLARE_ASP(asp_frag_threshold);
DECLARE_ASP(asp_rts_threshold);
DECLARE_ASP(asp_beacon_period);
DECLARE_ASP(asp_dtim_period);
DECLARE_ASP(asp_basic_data_rates);
DECLARE_ASP(asp_auth_mode);
DECLARE_ASP(asp_privacy_option);
DECLARE_ASP(asp_key_index);
DECLARE_ASP(asp_key_size);
DECLARE_ASP(asp_key_value);
DECLARE_ASP(asp_ag_client_sel_state);
DECLARE_ASP(asp_ag_client_sel);
DECLARE_ASP(asp_wpa_mode);
DECLARE_ASP(asp_wpa_cipher_suite);
DECLARE_ASP(asp_wpa2_cipher_suite);
DECLARE_ASP(asp_wpa_auth_method);
DECLARE_ASP(asp_wpa_encr_method);
DECLARE_ASP(asp_grp_rekey_time);
DECLARE_ASP(asp_bridge_mac);
DECLARE_ASP(asp_rsn_stats);
DECLARE_ASP(asp_dhcp_mode);
DECLARE_ASP(asp_ip_addr);
DECLARE_ASP(asp_accept_any_station);
DECLARE_ASP(asp_filter_list);
DECLARE_ASP(asp_filter_caption);
DECLARE_ASP(asp_sta_list);
DECLARE_ASP(asp_sta_list_cnt);
DECLARE_ASP(asp_error_message);
DECLARE_ASP(asp_error_redirect_url);
DECLARE_ASP(asp_get_privacy_option);
DECLARE_ASP(asp_get_wpa_mode);
DECLARE_ASP(asp_get_AP_mode);
DECLARE_ASP(asp_get_burst_mode);
DECLARE_ASP(asp_get_burst_rate);
DECLARE_ASP(asp_get_G_Protection_mode);
DECLARE_ASP(asp_ssid2);
DECLARE_ASP(asp_rf_channel2);
DECLARE_ASP(asp_data_rate_a);
DECLARE_ASP(asp_get_wipod_mode);
DECLARE_ASP(asp_banner_create);
#ifdef AP_SITE_SURVEY
DECLARE_ASP(asp_get_site_survey);
#endif /* AP_SITE_SURVEY */
#ifdef TURBO_SETUP_TEST
DECLARE_ASP(asp_data_autolink);
#endif
#ifndef SDRAM_4MB
#ifdef QOS_FEATURE
DECLARE_ASP(asp_qos_mode);
DECLARE_ASP(asp_noack_mode);
DECLARE_ASP(asp_qos_ts_list);
DECLARE_ASP(asp_wme_ac);
DECLARE_ASP(asp_wme_cwmin);
DECLARE_ASP(asp_wme_cwmax);
DECLARE_ASP(asp_wme_aifs);
DECLARE_ASP(asp_wme_txoplimit);
DECLARE_ASP(asp_wme_txoplimitB);
DECLARE_ASP(asp_wme_acm);
#endif
#endif
#if defined(GATEWAY) && defined(DHCPS)
DECLARE_ASP(asp_dhcp_server_mode);
DECLARE_ASP(asp_ip_server_addr);
DECLARE_ASP(asp_global_lease_time);
#endif
#if defined(DHCPS)
DECLARE_ASP(asp_dhcp_list);
DECLARE_ASP(asp_dhcp_global);
#endif

#if defined(GATEWAY)
DECLARE_ASP(asp_lan_ip_config);
DECLARE_ASP(asp_wan_ip_config);
#endif
#ifdef FLEXMODE_TEST
DECLARE_ASP(asp_get_nav_offset_value);
DECLARE_ASP(asp_get_flex_mode_beacon);
#endif
DECLARE_ASP(asp_WDS_ssid);
DECLARE_ASP(asp_WDS_Bssid);
DECLARE_ASP(asp_WDS_PrefBssid);
DECLARE_ASP(asp_UR_mode);
DECLARE_ASP(asp_urLinkStatus);
DECLARE_ASP(asp_WDS_ConnBssid);
#ifdef IEEE80211H
DECLARE_ASP(asp_get_SPECTRUM_MGMT_value);
DECLARE_ASP(asp_get_MITIGATION_value);
DECLARE_ASP(asp_get_CHANNEL_ANNOUNCEMENT_value);
DECLARE_ASP(asp_get_REGULATORY_DOMAIN_value);
#endif

#ifdef VOIP_GUI
DECLARE_ASP(asp_get_voip_cfg);
#endif

/* OPREGTEST */
DECLARE_ASP(asp_banner_create_opreg);
DECLARE_ASP(asp_regBBP_list);
DECLARE_ASP(asp_regRF_list);
DECLARE_ASP(asp_regMAC_list);

/* AUTOLINK */
DECLARE_ASP(asp_wpa_passphrase);
DECLARE_ASP(asp_al_low_power);
DECLARE_ASP(asp_al_enable);
DECLARE_ASP(asp_al_on_time);
DECLARE_ASP(asp_al_pp_enable);
DECLARE_ASP(asp_al_sec_mode);

#ifdef DCS
DECLARE_ASP(asp_dcsmode);
DECLARE_ASP(asp_dcsmodestatus);
DECLARE_ASP(asp_get_bss_bgscan);
DECLARE_ASP(asp_get_ch_bgscan);
#endif
DECLARE_ASP(asp_aging_time);

/* GUEST_ACCESS */
DECLARE_ASP(asp_guestaccess_enable);
DECLARE_ASP(asp_guestaccess_passphrase);
DECLARE_ASP(asp_guestaccess_passphrase2);

/*
 *	Strings to display error message and redirect URL
 *	error_message: Error message displayed on error dialog
 *	error_redirect_url: Redirected URL after the error message
 */

static char szErrorMessage[256] = "This is a sample error message.";
#ifdef AP_URPTR
static char szRedirectUrl[256] = "radio_ur.asp";
#else
#if defined(FALCON) || defined(PEREGRINE)
static char szRedirectUrl[256] = "radio_g.asp";
#else  
static char szRedirectUrl[256] = "radio.asp";
#endif
#endif

extern UINT8 wepClientType;

void dummy_AspDef(void) {
}

void asp_show_error_message(webs_t wp, char *message, char *redirect_url) {
    strcpy(szErrorMessage, message);
    strcpy(szRedirectUrl, redirect_url);
    websRedirect(wp, T("error.asp"));
}

void asp_define() {
    DEFINE_ASP(asp_channel_list1);
    DEFINE_ASP(asp_channel_list2);
    DEFINE_ASP(asp_channel_list3);    
    DEFINE_ASP(asp_AP_list);
    DEFINE_ASP(asp_wds_mode);
    DEFINE_ASP(asp_wds_bcast_mode);
    DEFINE_ASP(asp_get_disable_assoc);
    DEFINE_ASP(asp_ssid);
    DEFINE_ASP(asp_firmware_version);
    DEFINE_ASP(asp_bootcode_version);
    DEFINE_ASP(asp_open_ssid_en_state);
    DEFINE_ASP(asp_autolink);
    DEFINE_ASP(asp_boostermode);
    DEFINE_ASP(asp_boostermodestatus);
    DEFINE_ASP(asp_filtermode);
    DEFINE_ASP(asp_rf_preamble_option);
    DEFINE_ASP(asp_tx_antenna_mode);
    DEFINE_ASP(asp_rx_antenna_mode);
    DEFINE_ASP(asp_antenna_mode);
    DEFINE_ASP(asp_data_rate_b);
    DEFINE_ASP(asp_data_rate_g);
    DEFINE_ASP(asp_rf_channel);
    DEFINE_ASP(asp_rf_autochannel);
    DEFINE_ASP(asp_frag_threshold);
    DEFINE_ASP(asp_rts_threshold);
    DEFINE_ASP(asp_beacon_period);
    DEFINE_ASP(asp_dtim_period);
    DEFINE_ASP(asp_basic_data_rates);
    DEFINE_ASP(asp_auth_mode);
    DEFINE_ASP(asp_privacy_option);
    DEFINE_ASP(asp_key_index);
    DEFINE_ASP(asp_key_size);
    DEFINE_ASP(asp_key_value);
    DEFINE_ASP(asp_ag_client_sel_state);
    DEFINE_ASP(asp_ag_client_sel);
    DEFINE_ASP(asp_wpa_mode);
    DEFINE_ASP(asp_wpa_cipher_suite);
    DEFINE_ASP(asp_wpa2_cipher_suite);
    DEFINE_ASP(asp_wpa_auth_method);
    DEFINE_ASP(asp_wpa_encr_method);
    DEFINE_ASP(asp_grp_rekey_time);
    DEFINE_ASP(asp_rsn_stats);
    DEFINE_ASP(asp_bridge_mac);
    DEFINE_ASP(asp_dhcp_mode);
    DEFINE_ASP(asp_ip_addr);
    DEFINE_ASP(asp_accept_any_station);
    DEFINE_ASP(asp_filter_list);
    DEFINE_ASP(asp_filter_caption);
    DEFINE_ASP(asp_sta_list);
    DEFINE_ASP(asp_sta_list_cnt);
    DEFINE_ASP(asp_error_message);
    DEFINE_ASP(asp_error_redirect_url);
    DEFINE_ASP(asp_get_privacy_option);
    DEFINE_ASP(asp_get_wpa_mode);
    DEFINE_ASP(asp_get_AP_mode);
    DEFINE_ASP(asp_get_burst_mode);
    DEFINE_ASP(asp_get_burst_rate);
    DEFINE_ASP(asp_get_G_Protection_mode);
    DEFINE_ASP(asp_get_wipod_mode);
    DEFINE_ASP(asp_ssid2);
    DEFINE_ASP(asp_rf_channel2);
    DEFINE_ASP(asp_data_rate_a);

    DEFINE_ASP(asp_banner_create);
#ifndef SDRAM_4MB    
#ifdef QOS_FEATURE
    DEFINE_ASP(asp_qos_mode);
    DEFINE_ASP(asp_noack_mode);
    DEFINE_ASP(asp_qos_ts_list);
    DEFINE_ASP(asp_wme_ac);
    DEFINE_ASP(asp_wme_cwmin);
    DEFINE_ASP(asp_wme_cwmax);
    DEFINE_ASP(asp_wme_aifs);
    DEFINE_ASP(asp_wme_txoplimit);
    DEFINE_ASP(asp_wme_txoplimitB);
	DEFINE_ASP(asp_wme_acm);
#endif
#endif
#ifdef AP_SITE_SURVEY
    DEFINE_ASP(asp_get_site_survey);
#endif /* AP_SITE_SURVEY */
#ifdef TURBO_SETUP_TEST
    DEFINE_ASP(asp_data_autolink);
#endif

#if defined(GATEWAY) && defined(DHCPS)
    DEFINE_ASP(asp_dhcp_server_mode);
    DEFINE_ASP(asp_ip_server_addr);
    DEFINE_ASP(asp_global_lease_time);
#endif
#if defined(DHCPS)
    DEFINE_ASP(asp_dhcp_list);
    DEFINE_ASP(asp_dhcp_global);
#endif
#if defined(GATEWAY)
        DEFINE_ASP(asp_lan_ip_config);
        DEFINE_ASP(asp_wan_ip_config);
#endif
#ifdef FLEXMODE_TEST
    DEFINE_ASP(asp_get_nav_offset_value);
    DEFINE_ASP(asp_get_flex_mode_beacon);
#endif
    DEFINE_ASP(asp_WDS_ssid);
    DEFINE_ASP(asp_WDS_Bssid);
    DEFINE_ASP(asp_UR_mode);
    DEFINE_ASP(asp_WDS_PrefBssid);
    DEFINE_ASP(asp_urLinkStatus);
    DEFINE_ASP(asp_WDS_ConnBssid);
#ifdef IEEE80211H
    DEFINE_ASP(asp_get_SPECTRUM_MGMT_value);
    DEFINE_ASP(asp_get_MITIGATION_value);
    DEFINE_ASP(asp_get_CHANNEL_ANNOUNCEMENT_value);
    DEFINE_ASP(asp_get_REGULATORY_DOMAIN_value);
#endif

#ifdef VOIP_GUI
	DEFINE_ASP(asp_get_voip_cfg);
#endif


/* OPREGTEST */
    DEFINE_ASP(asp_banner_create_opreg);
    DEFINE_ASP(asp_regBBP_list);
    DEFINE_ASP(asp_regRF_list);
    DEFINE_ASP(asp_regMAC_list);

/* AUTOLINK */
    DEFINE_ASP(asp_wpa_passphrase);
    DEFINE_ASP(asp_al_low_power);
    DEFINE_ASP(asp_al_enable);
    DEFINE_ASP(asp_al_on_time);
    DEFINE_ASP(asp_al_pp_enable);
    DEFINE_ASP(asp_al_sec_mode);

#ifdef DCS
    DEFINE_ASP(asp_dcsmode);
    DEFINE_ASP(asp_dcsmodestatus);
    DEFINE_ASP(asp_get_bss_bgscan);
    DEFINE_ASP(asp_get_ch_bgscan);
#endif
	DEFINE_ASP(	asp_aging_time); 
/* GUEST_ACCESS */
    DEFINE_ASP(asp_guestaccess_enable);
    DEFINE_ASP(asp_guestaccess_passphrase);    
    DEFINE_ASP(asp_guestaccess_passphrase2);    
}
IMPLEMENT_ASP(asp_channel_list1){
    /* get channel */
    unsigned short nData,nData1, i=0;
    unsigned char channels[33];
    DECLARE_1_ASP_ARGS;
#ifdef DOMAIN_SUPPORTED
    domainGetInfo(channels);
#endif
    if ( ApCmdGetProc(APCMD_GET_RF_CHANNEL, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    if ( ApCmdGetProc(APCMD_GET_AP_MODE, (char*)&nData1) == STATUS_FAIL )
    {
        nData1 = DATA_ERROR;
    }
#ifdef AUTOCHANNEL
    if ( nData & 0x8000 )
    {
		nData = 0;
        websWrite(wp, T("<option selected>Auto </option>"));
    }
    else
    {
		nData &=0x7fff;
        websWrite(wp, T("<option>Auto </option>"));
    }
#endif
    while (i<33)  /** maximum a+g channel is 33 **/
    {
        
        switch (nData1)
        {
        case AP_MODE_A_ONLY:
        case AP_MODE_AandG:
#if 0
            if(channels[i] > 14)
#else
	     if(i>13 ) /** a channel start from 14 */
#endif
            {
      	     if(i>13 && channels[i]==0)
		 return;

#ifndef IEEE80211H         
                if ( nData == channels[i] )
                {
                    websWrite(wp, T("<option selected<%asp_rf_channel(%d); %>Channel %d</option>"), channels[i],channels[i]);
                }
                else
                    websWrite(wp, T("<option selected<%asp_rf_channel(%d); %>Channel %d</option>"), channels[i],channels[i]);
                    //websWrite(wp, T("<option <%%asp_rf_channel(%d); %%>>Channel %d</option>"), channels[i],channels[i]); <== should be like this
#else
            if ( nData == channels[i] )
            {
                websWrite(wp, T("<option selected>Channel %d</option>"), channels[i],channels[i]);
            }
            else               
                websWrite(wp, T("<option>Channel %d</option>"), channels[i],channels[i]);
#endif /* !IEEE80211H*/                 

            }
            break;
        case AP_MODE_B_ONLY:
        case AP_MODE_G_ONLY:
        case AP_MODE_MIXED:
		if(channels[i]==0)
		return;
#ifndef IEEE80211H            
#if 0
            if(channels[i] < 15)
#else
            if(i< 14)  /** max g channel is 1 to 13 **/

#endif
            {
                if ( nData == channels[i] )
                {
                    websWrite(wp, T("<option selected<%asp_rf_channel(%d); %>Channel %d</option>"), channels[i],channels[i]);
                }
                else
                    websWrite(wp, T("<option <%asp_rf_channel(%d); %>Channel %d</option>"), channels[i],channels[i]);
#else
#if 0
            if(channels[i] < 15)
#else
            if(i < 15)

#endif
            {
                if ( nData == channels[i] )
                {
                    websWrite(wp, T("<option selected>Channel %d</option>"), channels[i],channels[i]);
                }
                else
                    websWrite(wp, T("<option>Channel %d</option>"), channels[i],channels[i]);
#endif /* IEEE80211H */
            }
        default:
            break;
        }
        i++;
    }
}
IMPLEMENT_ASP(asp_channel_list2){
    /* get channel */
    unsigned short nData,nData1, i=0;
    unsigned char channels[33];
    DECLARE_1_ASP_ARGS;
    
#ifdef DOMAIN_SUPPORTED
    domainGetInfo(channels);
#endif

    if ( ApCmdGetProc(APCMD_GET_RF_CHANNEL2, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    if ( ApCmdGetProc(APCMD_GET_AP_MODE, (char*)&nData1) == STATUS_FAIL )
    {
        nData1 = DATA_ERROR;
    }
#ifdef AUTOCHANNEL
    if ( nData & 0x8000 )
    {
		nData = 0;
        websWrite(wp, T("<option selected>Auto </option>"));
    }
    else
    {
		nData &=0x7fff;
        websWrite(wp, T("<option>Auto </option>"));
    }
#endif
    while (i<33 && channels[i])
    {
#if 0
        if(channels[i] < 15)
#else
        if(i< 14)

#endif
        {
#ifndef IEEE80211H            
            if ( nData == channels[i] )
            {
                websWrite(wp, T("<option selected<%asp_rf_channel2(%d); %>Channel %d</option>"), channels[i],channels[i]);
            }
            else
            websWrite(wp, T("<option <%asp_rf_channel2(%d); %>Channel %d</option>"), channels[i],channels[i]);
#else
            if ( nData == channels[i] )
            {
                websWrite(wp, T("<option selected>Channel %d</option>"), channels[i],channels[i]);
            }
            else               
                websWrite(wp, T("<option>Channel %d</option>"), channels[i],channels[i]);
#endif /* !IEEE80211H*/ 
        }
        i++;
    }
}
IMPLEMENT_ASP(asp_channel_list3){
    /* get channel */
    unsigned short nData,nData1, i=0;
    unsigned char channels[33] = {0};
    unsigned char len, len_g, len_a;
    
    DECLARE_1_ASP_ARGS;
#ifdef DOMAIN_SUPPORTED
    domainGetInfo(channels);    
#endif 

    len = 33;
    len_g = 0;
    for (i=0; i <14; i++) 
    {
        if (channels[i] ==0)
        {
            len_g = i;
            break;
        }
    }
    if (!len_g)
        len_g = 14;
    for (i=15; i <33; i++) 
    {
        if (channels[i] ==0)
        {
            len_a = i;
            break;
        }
    }
    if (!len_a)
        len_a = 33;

    websWrite(wp, T("var channels_len = %d;\n"), len); 
    websWrite(wp, T("var channels_len_g = %d;\n"), len_g);
    websWrite(wp, T("var channels_len_a = %d;\n"), len_a);
    websWrite(wp, T("var channels_len = %d;\n"), len); 
    websWrite(wp, T("var channels = new Array(%d); \n"), len);

    for (i = 0; i<len; i++)
        websWrite(wp, T("channels[%d] = %d;\n"), i, channels[i]); 
}
IMPLEMENT_ASP(asp_AP_list) {
#ifdef WDS_FEATURE
    USHORT  nBufSize = MAX_WDS_AP_LIST*6+2, nCount;
    UCHAR   *pBuf, *pChar;

    // Get Filter Station List 
    //ApCmdGetProc(APCMD_GET_FILTER_BUFSIZE, (char*)&nBufSize);
    if ( 1 )
    {//nBufSize >= MIN_FILTER_LIST_BUF_SIZE) {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_WDS_LIST, (char*)pBuf) == STATUS_FAIL )
        {
            free (pBuf);
            pBuf = 0;
        }
    }
    else
    {
        pBuf = NULL;
    }

    if ( pBuf!=0 )
    {
        nCount = pBuf[0];
        pChar = pBuf+sizeof(USHORT);
        while ( nCount )
        {
            websWrite(wp, T("  <tr>\n"));
            websWrite(wp, T("    <td width=\"25%c\" align=\"center\">%d</td>\n"),
                      0x25, pBuf[0]-nCount);
            websWrite(wp, T("    <td width=\"75%c\"><input type=\"text\" name=\"WdsAp%d\" "
                            "value=\"%02X:%02X:%02X:%02X:%02X:%02X\" size=\"25\"></td>\n"),
                      0x25, pBuf[0]-nCount, *pChar, *(pChar+1), *(pChar+2), *(pChar+3),
                      *(pChar+4), *(pChar+5));
            websWrite(wp, T("  </tr>\n"));
            pChar += 6;
            nCount--;
        }
        free (pBuf);
    }
    nCount = pBuf[0];
    while ( nCount < MAX_WDS_AP_LIST )
    {
        websWrite(wp, T("  <tr>\n"));
        websWrite(wp, T("    <td width=\"25%c\" align=\"center\">%d</td>\n")
                  ,0x25, nCount);
        websWrite(wp, T("    <td width=\"75%c\"><input type=\"text\" name=\"WdsAp%d\" "
                        "value=\"00:00:00:00:00:00\" size=\"25\"></td>\n"),0x25, nCount);
        websWrite(wp, T("  </tr>\n"));
        nCount++;
    }
#endif
    return 1;
}

IMPLEMENT_ASP(asp_wds_mode) {
    UCHAR chData, chInput;
    DECLARE_1_ASP_ARGS;
#ifdef WDS_FEATURE
    if ( ApCmdGetProc(APCMD_GET_WDS_MODE, (char*)&chData) == STATUS_FAIL )
    {
        chData = (UCHAR)DATA_ERROR;
    }
    if ( strcmp(arg1, "disable") == 0 )
    {
        chInput = WDS_MODE_DISABLE;
    }
    else if ( strcmp(arg1, "static") == 0 )
    {
        chInput = WDS_MODE_STATIC;
    }
    else if ( strcmp(arg1, "dynamic") == 0 )
    {
        chInput = WDS_MODE_DYNAMIC;
    }
#endif
    return websWrite(wp, T(chData==chInput?"selected":""));
}
IMPLEMENT_ASP(asp_wds_bcast_mode) {
    UCHAR chData, chInput;
    DECLARE_1_ASP_ARGS;
#ifdef WDS_FEATURE
    if ( ApCmdGetProc(APCMD_GET_WDS_BCAST_MODE, (char*)&chData) == STATUS_FAIL )
    {
        chData = (UCHAR)DATA_ERROR;
    }
    if ( strcmp(arg1, "broadcast") == 0 )
    {
        chInput = WDS_MODE_DISABLE;
    }
    else if ( strcmp(arg1, "unicast") == 0 )
    {
        chInput = WDS_MODE_STATIC;
    }

#endif
    return websWrite(wp, T(chData==chInput?"selected":""));
}
IMPLEMENT_ASP(asp_get_disable_assoc) {
    UCHAR chData;
    DECLARE_0_ASP_ARGS;
#ifdef WDS_FEATURE
    if ( ApCmdGetProc(APCMD_GET_DISABLE_ASSOC, &chData) == STATUS_FAIL)
    {
        chData = FALSE;
    }
#endif
    return websWrite(wp, T(chData?"checked":"")); 
}
IMPLEMENT_ASP(asp_ssid) {
    char buf[64];
    unsigned char sLen, i, j;
    char buf2[100];
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_SSID, buf) == FAIL )
    {
        return websWrite(wp, T(""));
    }
    sLen = strlen(buf);
    memset(buf2, 0, 100);
    for ( i=0, j=0; i < sLen; i++ )
    {
        if ( buf[i]==0x22 )
        {
            buf2[j] = '&';
            j++;
            buf2[j] = '#';
            j++;
            buf2[j] = '3';
            j++;
            buf2[j] = '4';
            j++;
            buf2[j] = ';';
            j++;
        }
        else
        {
            buf2[j] = buf[i];
            j++;
        }
    }
    return websWrite(wp, T(buf2));
}

IMPLEMENT_ASP(asp_get_wipod_mode) {

    UCHAR apicmdbuf_wimode_body;/* This needs to be larger for other modes */
    UCHAR wiMode;
	DECLARE_1_ASP_ARGS;

#if defined(WIPOD)	
	if (ApCmdGetProc(APCMD_GET_WIPOD_MODE, (UCHAR *)&apicmdbuf_wimode_body) == STATUS_FAIL) {
		wiMode = 0;
	}
    wiMode = (!(apicmdbuf_wimode_body & WIPOD_TYPE_AP))? WIPOD_MODE_CLIENT_BRIDGE:0;

	if(strcmp(arg1, "string") == 0)
	{
		return websWrite(wp, T(wiMode?"WB":"AP"));
	}
	else if(strcmp(arg1, "WB") == 0) 
	{
		return websWrite(wp, T(wiMode?"checked":""));
	} 
#endif
	return websWrite(wp, T(wiMode?"":"checked"));
}
IMPLEMENT_ASP(asp_ssid2) {
    char buf[64];
    unsigned char sLen, i, j;
    char buf2[100];
    DECLARE_0_ASP_ARGS;

    if (ApCmdGetProc(APCMD_GET_SSID2, buf) == FAIL)
    {
        return websWrite(wp, T(""));
    }
    sLen = strlen(buf);
    memset(buf2, 0, 100);
    for (i=0, j=0; i < sLen; i++)
    {
        if (buf[i]==0x22)
        {
            buf2[j] = '&';
            j++;
            buf2[j] = '#';
            j++;
            buf2[j] = '3';
            j++;
            buf2[j] = '4';
            j++;
            buf2[j] = ';';
            j++;
        }
        else
        {
            buf2[j] = buf[i];
            j++;
        }
    }
    return websWrite(wp, T(buf2));
}




IMPLEMENT_ASP(asp_firmware_version) {
    char buf[64];
    DECLARE_0_ASP_ARGS;
#if 1
	memset(buf, 0, 64);
    if ( ApCmdGetProc(APCMD_GET_FIRMWARE_VERSION, buf) == STATUS_FAIL )
    {
        strcpy(buf, "Not Available");
    }
#else
    //GetSdkVersion(buf);
#endif
    return websWrite(wp, T(buf));
}

IMPLEMENT_ASP(asp_bootcode_version) {
    char buf[16], i;
    char *p;
    DECLARE_0_ASP_ARGS;
    
    p = (char *)0xFFFFFFF4; /* Address of bootcode version in flash */
    i = 0;
    while (*p != 0xFF)
    {
        buf[i++] = *p++;
        if (i >= 12) break;
    }
    buf[i] = 0;
    return websWrite(wp, T(buf));
}

IMPLEMENT_ASP(asp_open_ssid_en_state) {
    char chData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_OPEN_SSID_EN_STATE, &chData)==STATUS_FAIL )
    {
        chData = FALSE;
    }

    return websWrite(wp, T(chData?"checked":"")); 
}

IMPLEMENT_ASP(asp_aging_time) {	  
	ULONG lData;
    DECLARE_0_ASP_ARGS;

	if ( ApCmdGetProc(APCMD_GET_AGING_STATE, (char*)&lData) == STATUS_FAIL )
    {
		lData = 0;
    }
    return websWrite(wp, T("%d"), lData); 
}

IMPLEMENT_ASP(asp_autolink) {
    char chData;
    DECLARE_0_ASP_ARGS;
#if defined(TURBO_SETUP)
    if ( ApCmdGetProc(APCMD_GET_AUTO_LINK_MODE, &chData)==STATUS_FAIL )
    {
        chData = FALSE;
    }
    else
    {
        chData = (chData==4)?0:1;
    }
#elif defined(AUTOLINK)
    {
    APICMDBUF_GET_AL_ENABLE_STATE cmdBuf;
    cmdBuf.cmdCode = APCMD_GET_AL_ENABLE_STATE;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_AL_ENABLE_STATE)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    apctl(&cmdBuf);
    chData = cmdBuf.ALEnable;
    }
#else
    chData = FALSE;
    return websWrite(wp, T("disabled")); 
#endif

    return websWrite(wp, T(chData?"checked":"")); 
}

IMPLEMENT_ASP(asp_boostermode) {
    char chData, inData;
	DECLARE_1_ASP_ARGS;
#ifdef BOOSTER_MODE
    if ( ApCmdGetProc(APCMD_GET_BOOSTER_MODE, &chData)==STATUS_FAIL )
    {
		chData = (char)DATA_ERROR;
    }
#else
    chData = 0;
#endif
	if (strcmp(arg1, "auto") == 0) {
		inData = BOOSTER_AUTO;
	} else if (strcmp(arg1, "on") == 0) {
		inData = BOOSTER_ON;
	} else if (strcmp(arg1, "off") == 0) {
		inData = BOOSTER_OFF;
	}

	return websWrite(wp, T(chData==inData?"selected":""));
}
IMPLEMENT_ASP(asp_boostermodestatus) {
#ifdef BOOSTER_MODE
	return websWrite(wp, T("enabled"));
#else
	return websWrite(wp, T("disabled"));
#endif
}

IMPLEMENT_ASP(asp_filtermode) {
    char chData, inData;
	DECLARE_1_ASP_ARGS;
    if ( ApCmdGetProc(APCMD_GET_WLAN_FILTER_MODE, &chData)==STATUS_FAIL )
    {
		chData = (char)DATA_ERROR;
    }
	if (strcmp(arg1, "block") == 0) {
		inData = FILTER_MODE;
	} else if (strcmp(arg1, "allow") == 0) {
		inData = ACCESS_MODE;
	} else if (strcmp(arg1, "off") == 0) {
		inData = DISABLE_MODE;
	}

	return websWrite(wp, T(chData==inData?"selected":""));
}

IMPLEMENT_ASP(asp_rf_preamble_option) {
    char chData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RF_PREAMBLE_OPTION, &chData)==STATUS_FAIL )
    {
        chData = (char)DATA_ERROR;
    }

    if ( strcmp(arg1, "auto") == 0 )
    {
        inData = PREAMBLE_AUTO_SELECT;
    }
    else if ( strcmp(arg1, "short") == 0 )
    {
        inData = PREAMBLE_SHORT;
    }
    else if ( strcmp(arg1, "long") == 0 )
    {
        inData = PREAMBLE_LONG;
    }

    return websWrite(wp, T(chData==inData?"selected":""));
}
IMPLEMENT_ASP(asp_antenna_mode) {
    unsigned short nData, inData;
	unsigned short rxantenna, txantenna, diversity;

    DECLARE_1_ASP_ARGS;

    if (ApCmdGetProc(APCMD_GET_ANTENNA_MODE, (char*)&nData) == STATUS_FAIL)
    {
        nData = DATA_ERROR;
    }
    //return websWrite(wp, T(((nData&0xF0)>>4)==inData?"selected":""));
	rxantenna = (nData & 0x0f);
	txantenna = ((nData & 0xf0)>>4);
	diversity = ((nData & 0xf00)>>8);
    return websWrite(wp, T((diversity)==atoi(arg1)?"selected":""));
#if 0


    if (strcmp(arg1, "both") == 0)
    {
        inData = AP_ANT_DIVERSITY;
    }
    else if (strcmp(arg1, "ant1") == 0)
    {
        inData = AP_ANT_A;
    }
    else if (strcmp(arg1, "ant2") == 0)
    {
        inData = AP_ANT_B;
    }

    return websWrite(wp, T(((nData&0xF0)>>4)==inData?"selected":""));
#endif
}
IMPLEMENT_ASP(asp_tx_antenna_mode) {
    unsigned short nData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ANTENNA_MODE, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    if ( strcmp(arg1, "both") == 0 )
    {
        inData = AP_ANT_DIVERSITY;
    }
    else if ( strcmp(arg1, "ant1") == 0 )
    {
        inData = AP_ANT_A;
    }
    else if ( strcmp(arg1, "ant2") == 0 )
    {
        inData = AP_ANT_B;
    }

    return websWrite(wp, T(((nData&0xF0)>>4)==inData?"selected":""));
}

IMPLEMENT_ASP(asp_rx_antenna_mode) {
    unsigned short nData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ANTENNA_MODE, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    if ( strcmp(arg1, "both") == 0 )
    {
        inData = AP_ANT_DIVERSITY;
    }
    else if ( strcmp(arg1, "ant1") == 0 )
    {
        inData = AP_ANT_A;
    }
    else if ( strcmp(arg1, "ant2") == 0 )
    {
        inData = AP_ANT_B;
    }

    return websWrite(wp, T((nData&0x0F)==inData?"selected":""));
}

IMPLEMENT_ASP(asp_data_rate_b) {
    unsigned char nData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_TX_DATA_RATE, (char*)&nData) == STATUS_FAIL )
    {
        nData = (unsigned char)DATA_ERROR;
    }

    return websWrite(wp, T((unsigned char)atoi(arg1)==nData?"selected":""));
}

IMPLEMENT_ASP(asp_data_rate_g) {
    unsigned char nData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_TX_DATA_RATE_G, (char*)&nData) == STATUS_FAIL )
    {
        nData = (unsigned char)DATA_ERROR;
    }

    return websWrite(wp, T((unsigned char)atoi(arg1)==nData?"selected":""));
}

IMPLEMENT_ASP(asp_data_rate_a) {
    unsigned char nData;
    DECLARE_1_ASP_ARGS;

    if (ApCmdGetProc(APCMD_GET_TX_DATA_RATE_A, (char*)&nData) == STATUS_FAIL)
    {
        nData = (unsigned char)DATA_ERROR;
    }

    return websWrite(wp, T((unsigned char)atoi(arg1)==nData?"selected":""));
}


IMPLEMENT_ASP(asp_rf_channel) {
    unsigned short nData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RF_CHANNEL, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }
#ifdef AUTOCHANNEL
    if ( nData & 0x8000 )
    {
		nData = 0;
    }
    else
    {
		nData &=0x7fff;
    }
#endif
#ifdef IEEE80211H
    if(strcmp(arg1, "channel") == 0 ){
        return websWrite(wp, T("%d"), nData);
    }
#endif /* IEEE80211H */



    return websWrite(wp, T((nData)==atoi(arg1)?"selected":""));
}
IMPLEMENT_ASP(asp_rf_autochannel) {
    unsigned short nData, nData1;
    unsigned short mode;

    DECLARE_1_ASP_ARGS;
	
	mode = atoi(arg1);
    if ( ApCmdGetProc(APCMD_GET_RF_CHANNEL, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }
    if ( ApCmdGetProc(APCMD_GET_AP_MODE, (char*)&nData1) == STATUS_FAIL )
    {
        nData1 = DATA_ERROR;
	}
    switch (nData1)
	{
    case AP_MODE_A_ONLY:
		if(mode)
	        return websWrite(wp, T(""));
        break;
    case AP_MODE_AandG:
		if(mode)
		{
			if ( ApCmdGetProc(APCMD_GET_RF_CHANNEL2, (char*)&nData) == STATUS_FAIL )
    		{
    		    nData = DATA_ERROR;
    		}
		}
        break;
    case AP_MODE_B_ONLY:
    case AP_MODE_G_ONLY:
    case AP_MODE_MIXED:
    default:
		if(mode)
	        return websWrite(wp, T(""));	
        break;
	}
#ifdef AUTOCHANNEL
    if ( nData & 0x8000 )
    {
        nData &=0x7fff;
		if(nData)
        	return websWrite(wp, T("   - Channel %d"), nData);
    }
#endif
    return websWrite(wp, T(""));	
}

IMPLEMENT_ASP(asp_rf_channel2) {
    unsigned short nData;
    DECLARE_1_ASP_ARGS;

    if (ApCmdGetProc(APCMD_GET_RF_CHANNEL2, (char*)&nData) == STATUS_FAIL)
    {
        nData = DATA_ERROR;
    }
#ifdef AUTOCHANNEL
    if ( nData & 0x8000 )
    {
		nData = 0;
    }
    else
    {
		nData &=0x7fff;
    }
#endif
    return websWrite(wp, T((nData)==atoi(arg1)?"selected":""));
}


IMPLEMENT_ASP(asp_frag_threshold) {
    USHORT nData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_FRAG_THRESHOLD, (char*)&nData) == STATUS_FAIL )
    {
        nData = 0;
    }
    if ( nData < FRAG_THRESHOLD_MIN )
    {
        nData = FRAG_THRESHOLD_MIN;
    }
    if ( nData > FRAG_THRESHOLD_MAX )
    {
        nData = FRAG_THRESHOLD_MAX;
    }

    return websWrite(wp, T("%d"), nData);
}

IMPLEMENT_ASP(asp_rts_threshold) {
    USHORT nData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RTS_THRESHOLD, (char*)&nData) == STATUS_FAIL )
    {
        nData = 0;
    }
    if ( nData > RTS_THRESHOLD_MAX )
    {
        nData = RTS_THRESHOLD_MAX;
    }

    return websWrite(wp, T("%d"), nData);
}

IMPLEMENT_ASP(asp_beacon_period) {
    ULONG lData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_BEACON_PERIOD, (char*)&lData) == STATUS_FAIL )
    {
        lData = 0;
    }

    return websWrite(wp, T("%d"), lData);
}

IMPLEMENT_ASP(asp_dtim_period) {
    ULONG lData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_DTIM_PERIOD, (char*)&lData) == STATUS_FAIL )
    {
        lData = 0;
    }

    return websWrite(wp, T("%d"), lData);
}

/*
 *	The basic data rates of 802.11B and 802.11G are different.
 *  The GUI need to be changed for it.  The basic data rates
 *	of 802.11G are used at the time being.
 */
IMPLEMENT_ASP(asp_basic_data_rates) {
    UCHAR dataRates[16];
    int i;
    char szDisplay[16];
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_BASIC_DATA_RATES_G, (char*)dataRates) == STATUS_FAIL )
    {
        memset(dataRates, 0, sizeof(dataRates));
    }

    /*
     *	The Basic Data Rates are packed in an 8 bytes unsigned char
     *  array.  The MSB of each byte indicates whether this mode is
     *	enabled.  The rest of bits indcate the basic date rates,
     *  which is the two-time of number displayed in the web page.
     *  Enabling the higher data rate also enable the date rates
     *  lower than it.
     */
    for ( i = 0, strcpy(szDisplay, ""); i < sizeof(dataRates)/sizeof(dataRates[0]); i++ )
    {
        if ( (dataRates[i] & 0x7F) == atoi(arg1) )
        {
            strcpy(szDisplay, (dataRates[i]&0x80)?"checked":"");
            break;
        }
    }

    return websWrite(wp, T(szDisplay));
}

IMPLEMENT_ASP(asp_auth_mode) {
    UCHAR chData, chInput;
    DECLARE_1_ASP_ARGS;

#ifdef AG_MIXED_SECURITY
    if (wepClientType == 1)
    {
        if (ApCmdGetProc(APCMD_GET_AUTH_MODE_G, (char*)&chData) == STATUS_FAIL)
        {
            chData = (UCHAR)DATA_ERROR;
        }
    }
    else
#endif
    {
    if ( ApCmdGetProc(APCMD_GET_AUTH_MODE, (char*)&chData) == STATUS_FAIL )
    {
        chData = (UCHAR)DATA_ERROR;
    }
    }
    if ( strcmp(arg1, "open") == 0 )
    {
        chInput = OPEN_SYSTEM_ONLY;
    }
    else if ( strcmp(arg1, "shared") == 0 )
    {
        chInput = SHARED_KEY_ONLY;
    }
    else if ( strcmp(arg1, "both") == 0 )
    {
        chInput = OPEN_SYSTEM_AND_SHARED_KEY;
    }

    return websWrite(wp, T(chData==chInput?"selected":""));
}

IMPLEMENT_ASP(asp_privacy_option) {
    UCHAR chData, chInput;
    char szDisplay[16];
    DECLARE_1_ASP_ARGS;

#ifdef AG_MIXED_SECURITY
    if (wepClientType == 1)
    {
        if (ApCmdGetProc(APCMD_GET_PRIVACY_OPTION_G, &chData) == STATUS_FAIL)
        {
            chData = (UCHAR)DATA_ERROR;
        }
    }
    else
#endif
    {
    if ( ApCmdGetProc(APCMD_GET_PRIVACY_OPTION, &chData) == STATUS_FAIL )
    {
        chData = (UCHAR) DATA_ERROR;
    }
    }
    if ( strcmp(arg1, "not") == 0 )
    {
        chInput = DATA_ENCRYPT_NOT_REQUIRED;

    }
    else
    {
        chInput = FULL_DATA_ENCRYPT_REQUIRED;

    }

    if ( chData == DATA_ENCRYPT_NOT_REQUIRED )
    {
        WepEnabled=FALSE;
        sprintf(szDisplay, "%s", chInput==chData?"selected":"");
    }
    else
    {
        WepEnabled=TRUE;
        sprintf(szDisplay, "%s", chInput!=DATA_ENCRYPT_NOT_REQUIRED?"selected":"");
    }

    return websWrite(wp, T("%s"), szDisplay);
}

IMPLEMENT_ASP(asp_key_index) {
    WEP_KEY wep;
    DECLARE_1_ASP_ARGS;

#ifdef AG_MIXED_SECURITY
    if (wepClientType == 1)
    {
        if (ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS_G, (char*)&wep) == STATUS_FAIL)
        {
            memset(&wep, 0, sizeof(WEP_KEY));
        }
    }
    else
#endif
    {
    if ( ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS, (char*)&wep) == STATUS_FAIL )
    {
        memset(&wep, 0, sizeof(WEP_KEY));
    }
    }

    return websWrite(wp, T(wep.TxKeyIndex+1==atoi(arg1)?"selected":""));
}

IMPLEMENT_ASP(asp_key_size) {
    WEP_KEY wep;
    USHORT nData, inData;
    DECLARE_1_ASP_ARGS;

#ifdef AG_MIXED_SECURITY
    if (wepClientType == 1)
    {
        if (ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS_G, (char*)&wep) == STATUS_FAIL)
        {
            memset(&wep, 0, sizeof(WEP_KEY));
        }
    }
    else
#endif
    {
    if ( ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS, (char*)&wep) == STATUS_FAIL )
    {
        memset(&wep, 0, sizeof(WEP_KEY));
    }
    }
    switch ( wep.TxKeyIndex )
    {
    case 0:
        nData = wep.keyType0;
        break;
    case 1:
        nData = wep.keyType1;
        break;
    case 2:
        nData = wep.keyType2;
        break;
    case 3:
        nData = wep.keyType3;
        break;
    }

    if ( strcmp(arg1, "not") == 0 )
    {
        inData = WEP_NOT_SET;
    }
    else if ( strcmp(arg1, "40") == 0 )
    {
        inData = WEP_40_BIT;
    }
    else if ( strcmp(arg1, "104") == 0 )
    {
        inData = WEP_104_BIT;
    }

    return websWrite(wp, T(nData==inData?"selected":""));
}

IMPLEMENT_ASP(asp_key_value) {
    WEP_KEY wep;
    unsigned char *pKey;
	int keytype;
    char szDisplay[27];
    int i;
    DECLARE_1_ASP_ARGS;
    if (ApCmdGetProc(APCMD_GET_DEFAULT_WEP_KEYS, (char*)&wep) == STATUS_FAIL) {
        memset(&wep, 0, sizeof(WEP_KEY));
    }

    switch(atoi(arg1)) {
    case 1:
        pKey = wep.keyValue0;
		keytype = wep.keyType0;
        break;
    case 2:
        pKey = wep.keyValue1;
		keytype = wep.keyType1;
        break;
    case 3:
        pKey = wep.keyValue2;
		keytype = wep.keyType2;
        break;
    case 4:
        pKey = wep.keyValue3;
		keytype = wep.keyType3;
        break;
    }

    for (i = 0; i < 26; i++) {
        if (i % 2 == 0)
            sprintf(szDisplay + i, "%X", (*(pKey+i/2)&0xF0)>>4);
        else
            sprintf(szDisplay + i, "%X", (*(pKey+i/2)&0x0F));
    }
    for (i = 26; i > 0; i--)
        if (szDisplay[i - 1] != '0')
            break;
	switch(keytype)
	{
		case 0:
    		szDisplay[0] = '\0';
			break;
		case 1:
    		szDisplay[10] = '\0';
			break;
		case 2:
    		szDisplay[26] = '\0';
			break;
		default:
    		szDisplay[0] = '\0';
			break;
	}
    /* Uncomment the following lines to display the "*" for WEP Keys */
//    memset(szDisplay, '*', 10 * sizeof(char)); 
//    szDisplay[10] = '\0';
    return websWrite(wp, T("%s"), szDisplay);
}
IMPLEMENT_ASP(asp_ag_client_sel_state) {
    DECLARE_0_ASP_ARGS;

#ifdef AG_MIXED_SECURITY
    return websWrite(wp, T(mib_ApMode == AP_MODE_AandG? "" : "disabled")); 
#else
    return websWrite(wp, T("disabled")); 
#endif
}

IMPLEMENT_ASP(asp_ag_client_sel) {
    UCHAR chInput;
    DECLARE_1_ASP_ARGS;

    if (strcmp(arg1, "ClientA") == 0)
        chInput = 0;
    else if (strcmp(arg1, "ClientG") == 0)
        chInput = 1;
    else
        chInput = 2;

    return websWrite(wp, T(wepClientType == chInput? "selected" : ""));
}

#if 1//def AP_WPA2
IMPLEMENT_ASP(asp_wpa_mode) {
	UCHAR chData, chInput, mibWPAMode;
	DECLARE_1_ASP_ARGS;

	if (ApCmdGetProc(APCMD_GET_PRIVACY_TBL_RSN_ENABLED, (char*)&mibWPAMode) == STATUS_FAIL) 
		chData = 0; 

    if (mibWPAMode)
    {
	    chData = 1;
		WpaEnabled=TRUE;	
	}
	else
	{
	    chData = 0;
		WpaEnabled=FALSE; 
	}
#ifdef AP_WPA2
	if (ApCmdGetProc(APCMD_GET_WPA2_ENABLED, (char*)&mibWPAMode) == STATUS_FAIL) 
		chData = 0; 

    if (mibWPAMode)
	    chData = 2;
    else if (!WpaEnabled) 
	    chData = 0;

	if (ApCmdGetProc(APCMD_GET_WPA2ONLY_ENABLED, (char*)&mibWPAMode) == STATUS_FAIL) 
		chData = 0; 

    if (mibWPAMode)
	    chData = 3;
    else if (!WpaEnabled) 
	    chData = 0;
#endif
	if (strcmp(arg1, "WPAEnabled") == 0)
		chInput = 1;
	else if (strcmp(arg1, "WPA_WPA2_MixedEnabled") == 0)
		chInput = 2;
	else if (strcmp(arg1, "WPA2_OnlyEnabled") == 0)
		chInput = 3;
	else
		chInput = 0;

	return websWrite(wp, T(chData==chInput?"selected":""));
}
#endif
IMPLEMENT_ASP(asp_wpa_cipher_suite) {
	UCHAR chSuites[4];
	UCHAR chInput = 0;
	DECLARE_1_ASP_ARGS;

	if (ApCmdGetProc(APCMD_GET_RSN_CFG_UNICAST_CIPHER, (char*)chSuites) == STATUS_FAIL) {
		chSuites[3] = 0;
	}
	if(strcmp(arg1, "tkip") == 0) {
		chInput = 2;
	} else if (strcmp(arg1, "ccmp") == 0) {
		chInput = 4;
	}

	return websWrite(wp, T(chSuites[3]==chInput?"selected":""));
}

IMPLEMENT_ASP(asp_wpa2_cipher_suite) {
	UCHAR chSuites[4];
	UCHAR chInput = 0;
	DECLARE_1_ASP_ARGS;
#ifdef AP_WPA2
	if (ApCmdGetProc(APCMD_GET_RSN_CFG_WPA2_UNICAST_CIPHER2, (char*)chSuites) == STATUS_FAIL) {
		chSuites[3] = 0;
	}
#endif
	if(strcmp(arg1, "ccmp") == 0) {
		chInput = 4;
	} 
/*    else if (strcmp(arg1, "ccmp_or_tkip") == 0) {
		chInput = 2;
	}
*/
	return websWrite(wp, T(chSuites[3]==chInput?"selected":""));
}


IMPLEMENT_ASP(asp_wpa_auth_method) {
	UCHAR chSuites[4];
	UCHAR chInput = 0;
	DECLARE_1_ASP_ARGS;

#ifdef AP_WPA2
	if (ApCmdGetProc(APCMD_GET_RSN_CFG_AUTH_SUITE, (char*)chSuites) == STATUS_FAIL) {
		chSuites[3] = 0;
	}
#endif
	if(strcmp(arg1, "pre_shared_keys") == 0) {
		chInput = 2;
	} else if (strcmp(arg1, "802.1x") == 0) {
		chInput = 1;
	}

	return websWrite(wp, T(chSuites[3]==chInput?"selected":""));
}

IMPLEMENT_ASP(asp_wpa_encr_method) {
    UCHAR chSuites[4];
    UCHAR chInput = 0;
    APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER cipher_mode;
    DECLARE_1_ASP_ARGS;
/*
    if (ApCmdGetProc(APCMD_GET_RSN_CFG_UNICAST_CIPHER, (char*)chSuites) == STATUS_FAIL)
    {
        chSuites[3] = 0;
    }
*/    
    cipher_mode.cmdCode = APCMD_GET_RSN_CFG_UNICAST_CIPHER;
    cipher_mode.cmdBodyLen = sizeof(APICMDBUF_GET_RSN_CFG_UNICAST_CIPHER)-BUF_HDR_LEN;
    cipher_mode.seqNum = 1;
    apctl(&cipher_mode);

    if (strcmp(arg1, "TKIP") == 0)
    {
        chInput = 2;
    }
    if (strcmp(arg1, "CCMP") == 0)
    {
        chInput = 4;
    }
    else
        chInput = 0;


    return websWrite(wp, T(cipher_mode.UnicastCipher[3]==chInput?"selected":""));
}

IMPLEMENT_ASP(asp_rsn_stats) {
    APICMDBUF_GET_RSN_STATS rsnStats;
    ULONG lData = 0;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RSN_STATS, (char*)&rsnStats) == STATUS_FAIL )
    {
        lData = 0;
    }
    else
    {
        if ( strcmp(arg1, "icv_errors") == 0 )
        {
            lData = rsnStats.TKIPICVErrors;
        }
        else if ( strcmp(arg1, "local_mic_failures") == 0 )
        {
            lData = rsnStats.TKIPLocalMICFailures;
        }
        else if ( strcmp(arg1, "remote_mic_failures") == 0 )
        {
            lData = rsnStats.TKIPRemoteMICFailures;
        }
        else if ( strcmp(arg1, "counter_measures_invoked") == 0 )
        {
            lData = rsnStats.TKIPCounterMeasuresInvoked;
        }
    }

    return websWrite(wp, T("%u"), lData); 
}

IMPLEMENT_ASP(asp_grp_rekey_time) {
    APICMDBUF_GET_RSN_CFG_TBL rsnCfg;
    ULONG lData = 0;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_RSN_CFG_TBL, (char*)&rsnCfg) == STATUS_FAIL )
    {
        lData = 0;
    }
    else
    {
        lData = rsnCfg.GroupRekeyTime;
    }

    return websWrite(wp, T("%u"), lData); 
}

IMPLEMENT_ASP(asp_bridge_mac) {
    unsigned char mac[6];
    DECLARE_1_ASP_ARGS;

    memset(mac, 0, 6);
    if ( strcmp(arg1, "wan_mac") == 0 )
    {
        //GetWanMac(mac);
    }
    else if ( strcmp(arg1, "lan_mac") == 0 )
    {
        //GetLanMac(mac);
    }
    else if ( strcmp(arg1, "gw_wan_mac") == 0 )
    {
        //GetGwWanMac(mac);
    }
    else if ( strcmp(arg1, "gw_lan_mac") == 0 )
    {
        //GetGwLanMac(mac);
    }
    else if ( strcmp(arg1, "wlan_mac") == 0 )
    {
        //GetWlanMac(mac);
    }

    return websWrite(wp, T("%02X:%02X:%02X:%02X:%02X:%02X"), mac[0], mac[1],
                     mac[2], mac[3], mac[4], mac[5]);
}

IMPLEMENT_ASP(asp_dhcp_mode) {
    UCHAR pBuf[16];
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_IP_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
        memset(pBuf, 0, sizeof(pBuf));
    }

    if ( strcmp(arg1, "enabled") == 0 )
    {
        return websWrite(wp, T((ULONG)(*(ULONG*)pBuf)?"checked":""));
    }
    else
    {
        return websWrite(wp, T((ULONG)(*(ULONG*)pBuf)?"":"checked"));
    }
}

IMPLEMENT_ASP(asp_ip_addr) {
    UCHAR pBuf[16];
    int nFirst;
    DECLARE_2_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_IP_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
        memset(pBuf, 0, sizeof(pBuf));
    }

    if ( strcmp(arg1, "ip") == 0 )
    {
        /* IP Address starts from the 4th byte */
        nFirst = 4;
    }
    else if ( strcmp(arg1, "mask") == 0 )
    {
        /* Subnet Mask starts from the 8th byte */
        nFirst = 8;
    }
    else if ( strcmp(arg1, "gateway") == 0 )
    {
        /* Default Getway IP Address starts from 12 byte */
        nFirst = 12;
    }

    return websWrite(wp, T("%u"), pBuf[nFirst + atoi(arg2) - 1]);
}

IMPLEMENT_ASP(asp_accept_any_station) {
    USHORT nBufSize = 0;
    UCHAR *pBuf = NULL;
    int isChecked;
    DECLARE_0_ASP_ARGS;

    /*
     *	"Accept Any Station" is determined by number of entry in the filter
     *	list, so the whole list is retrieved.  Further improvement of the
     *	interface is recommanded.
     */
    if ( ApCmdGetProc(APCMD_GET_WLAN_FILTER_LIST, (char*)&nBufSize) == STATUS_FAIL )
    {
        nBufSize = 0;
    }

    /* Get the filter list only when a least one entry is available*/
    if ( nBufSize >= MIN_FILTER_LIST_BUF_SIZE )
    {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_WLAN_FILTER_LIST, (char*) pBuf) != STATUS_FAIL )
        {
            isChecked = (*(pBuf+1) <= 0) && (*pBuf <= 0);
        }
        free(pBuf);
    }
    else
    {
        isChecked = 1;
    }

    return websWrite(wp, T(isChecked?"checked":""));
}

/*
 *	The following function is directly adopted from the original code segment
 *	in Mvrap.c.
 */
IMPLEMENT_ASP(asp_filter_list) {
    USHORT  nBufSize =0, nCount;
    UCHAR   *pBuf, *pChar;

    // Get Filter Station List 
    ApCmdGetProc(APCMD_GET_WLAN_FILTER_LIST, (char*)&nBufSize);
    if ( nBufSize >= MIN_FILTER_LIST_BUF_SIZE )
    {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_WLAN_FILTER_LIST, (char*)pBuf) == STATUS_FAIL )
        {
            free (pBuf);
            pBuf = 0;
        }
    }
    else
    {
        pBuf = NULL;
    }

    nCount = 1;
    if ( pBuf!=0 )
    {
        pChar = pBuf+sizeof(USHORT);
        while ( (nCount * 6)< nBufSize )
        {
            websWrite(wp, T("  <tr>\n"));
            websWrite(wp, T("    <td width=\"25%c\" align=\"center\">%d</td>\n"),
                      0x25, nCount);
            websWrite(wp, T("    <td width=\"75%c\"><input type=\"text\" name=\"Sta%d\" "
                            "value=\"%02X:%02X:%02X:%02X:%02X:%02X\" size=\"25\"></td>\n"),
                      0x25, nCount, *pChar, *(pChar+1), *(pChar+2), *(pChar+3),
                      *(pChar+4), *(pChar+5));
            websWrite(wp, T("  </tr>\n"));
            pChar += 6;
            nCount ++;
        }
        free (pBuf);
    }
    while ( nCount <= MAX_STA_IN_FILTER_LIST )
    {
        websWrite(wp, T("  <tr>\n"));
        websWrite(wp, T("    <td width=\"25%c\" align=\"center\">%d</td>\n")
                  ,0x25, nCount);
        websWrite(wp, T("    <td width=\"75%c\"><input type=\"text\" name=\"Sta%d\" "
                        "value=\"00:00:00:00:00:00\" size=\"25\"></td>\n"),0x25, nCount);
        websWrite(wp, T("  </tr>\n"));
        nCount++;
    }

    return 1;
}

IMPLEMENT_ASP(asp_filter_caption) {
    UCHAR   chData;

    if ( ApCmdGetProc(APCMD_GET_WLAN_FILTER_MODE, &chData)==STATUS_FAIL )
    {
		chData = (char)DATA_ERROR;
    }
    switch (chData) {
    case FILTER_MODE:
        websWrite(wp, T("Stations not allowed to be associated:"));
        break;
    case ACCESS_MODE:
        websWrite(wp, T("Stations allowed to be associated:"));
        break;
    case DISABLE_MODE:
        websWrite(wp, T("Stations list not applicable:"));
        break;
    }
    return 1;
}

/*
 *	The following function is directly adopted from the original code segment
 *	in Mvrap.c.
 */
#ifdef STA_INFO_DB
typedef struct RATE_t
{
    UINT8 *RateS;
}RATE_t;
RATE_t rate[14] = {"1M","2M","5.5M","11M","22M",
    "6M","9M","12M","18M","24M","36M","48M","54M","72M"};
#endif
IMPLEMENT_ASP(asp_sta_list) {
    USHORT  nBufSize =0, nCount;
    char    *pBuf;
    UCHAR   *pChar;
    DECLARE_0_ASP_ARGS;

    // Get STA List 
    ApCmdGetProc(APCMD_GET_STA_LIST, (char*)&nBufSize);
    if ( nBufSize >= MIN_STA_LIST_BUF_SIZE )
    {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_STA_LIST, pBuf) == STATUS_FAIL )
        {
            free(pBuf);
            pBuf = 0;
        }
    }
    else
    {
        pBuf = NULL;
    }
    websWrite(wp, T("  <tr>\n"));
#ifdef STA_INFO_DB
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"No");
    websWrite(wp, T("    <td width=\"30%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"MAC Address");
    websWrite(wp, T("    <td width=\"15%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Status");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Mode");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Rate");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Signal Quality");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"RSSI");
#ifdef GUEST_ACCESS
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Power Save");
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Guest Access");
#else
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Power Save");
#endif                                                                                         
#else                                                                                          
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"No");
    websWrite(wp, T("    <td width=\"50%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"MAC Address");
    websWrite(wp, T("    <td width=\"40%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Status");
#endif                                                                                         
    websWrite(wp, T("  </tr>\n"));

#ifdef STA_INFO_DB
    nBufSize =  pBuf[0] * sizeof(STA_INFO) + 2 ;
    if ( pBuf != NULL )
    {
        nCount = 1;
        pChar = pBuf + sizeof(USHORT);
        while ( (nCount * sizeof(STA_INFO))< nBufSize )
        {
            websWrite(wp, T("  <tr>\n"));
            websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%d</td>\n"),0x25, nCount);
            websWrite(wp, T("    <td width=\"30%c\" align=\"center\">%02X:%02X:%02X:%02X:%02X:%02X</td>\n"),
                      0x25, *pChar, *(pChar+1), *(pChar+2), *(pChar+3), *(pChar+4), *(pChar+5));                      
            websWrite(wp, T("    <td width=\"15%c\" align=\"center\">%s</td>\n"),
                      0x25, *(pChar+6)==FALSE? "Authenticated":"Associated");
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%s</td>\n"),0x25, *(pChar+7)?(*(pChar+7)==1?"g":(*(pChar+7)==2?"g/b":"a")):"b");
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%s</td>\n"),0x25, rate[*(pChar+8)].RateS);
            if(*(pChar+8) < 5)
            	websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%d</td>\n"),0x25, *(pChar+10));
			else
            	websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%d</td>\n"),0x25, *(pChar+9));
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%d</td>\n"),0x25, *(pChar+11));
#ifdef GUEST_ACCESS
            websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25, *(pChar+12)?"Yes":"No");
            websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%d</td>\n"),0x25, extStaDb_GetGuestAccess((IEEEtypes_MacAddr_t *)pChar));
#else            
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%s</td>\n"),0x25, *(pChar+12)?"Yes":"No");
#endif
            websWrite(wp, T("  </tr>\n"));
            pChar += sizeof(STA_INFO);
            nCount ++;
        }
        free(pBuf);
    }

#else
    if ( pBuf != NULL )
    {
        nCount = 1;
        pChar = pBuf + sizeof(USHORT);
        while ( (nCount * 8)< nBufSize )
        {
            websWrite(wp, T("  <tr>\n"));
            websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%d</td>\n"),0x25, nCount);
            websWrite(wp, T("    <td width=\"50%c\" align=\"center\">%02X:%02X:%02X:%02X:%02X:%02X</td>\n"),
                      0x25, *pChar, *(pChar+1), *(pChar+2), *(pChar+3), *(pChar+4), *(pChar+5));                      
            websWrite(wp, T("    <td width=\"40%c\" align=\"center\">%s</td>\n"),
                      0x25, *((USHORT*)(pChar+6))==FALSE? "Authenticated":"Associated");
            websWrite(wp, T("  </tr>\n"));
            pChar += 8;
            nCount ++;
        }
        free(pBuf);
    }
#endif
    return 1;
}

IMPLEMENT_ASP(asp_sta_list_cnt) {
    USHORT  nBufSize, nCount=0;
    char    *pBuf;
    UCHAR   *pChar;
    DECLARE_0_ASP_ARGS;

    // Get STA List 
    ApCmdGetProc(APCMD_STALIST_BUFSIZE, (char*)&nBufSize);
    if ( nBufSize >= MIN_STA_LIST_BUF_SIZE )
    {
        pBuf = malloc(nBufSize);
        *((USHORT*)pBuf) = nBufSize;
        if ( ApCmdGetProc(APCMD_GET_STA_LIST, pBuf) == STATUS_FAIL )
        {
            free(pBuf);
            pBuf = 0;
        }
    }
    else
    {
        pBuf = NULL;
    }

    if ( pBuf != NULL )
    {
#if defined(UDP_API) || defined(AP_PCI) || defined(STA_INFO_DB)
        nCount = *((USHORT *)&pBuf[0]);
#else
        nCount = ((USHORT)pBuf[0] << 8 ) + (USHORT)pBuf[1];
#endif        
        free(pBuf);
    }

    return websWrite(wp, "%d", nCount);;
}
IMPLEMENT_ASP(asp_error_message) {
    DECLARE_0_ASP_ARGS;

    return websWrite(wp, "%s", szErrorMessage);
}

IMPLEMENT_ASP(asp_error_redirect_url) {
    DECLARE_0_ASP_ARGS;

    return websWrite(wp, "%s", szRedirectUrl);
}

IMPLEMENT_ASP(asp_get_privacy_option) {

    UCHAR chData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_PRIVACY_OPTION, &chData) == STATUS_FAIL )
    {
        chData = (UCHAR) DATA_ERROR;
    }
    if ( chData == DATA_ENCRYPT_NOT_REQUIRED )
    {
        WepEnabled=FALSE; 
    }
    else
    {
        WepEnabled=TRUE; 
    }   
    return;
}

IMPLEMENT_ASP(asp_get_wpa_mode) {

    UCHAR chData;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_PRIVACY_TBL_RSN_ENABLED, (char*)&chData) == STATUS_FAIL )
    {
        chData = 0; 
    }
    if ( chData==1 )
    {
        WpaEnabled=TRUE;    
    }
    else
    {
        WpaEnabled=FALSE; 
    }
    return;
}

IMPLEMENT_ASP(asp_get_AP_mode) {

    unsigned short nData, inData;
    DECLARE_1_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_AP_MODE, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

    if ( strcmp(arg1, "b_mode") == 0 )
    {
        inData = AP_MODE_B_ONLY;
    }
    else if ( strcmp(arg1, "g_mode") == 0 )
    {
        inData = AP_MODE_G_ONLY;
    }
    else if ( strcmp(arg1, "mix_mode") == 0 )
    {
        inData = AP_MODE_MIXED;
    }
    else if (strcmp(arg1, "a_mode") == 0)
    {
        inData = AP_MODE_A_ONLY;
    }
    else if (strcmp(arg1, "ag_mode") == 0)
    {
        inData = AP_MODE_AandG;
    }



    return websWrite(wp, T(nData==inData?"selected":""));

}

IMPLEMENT_ASP(asp_get_burst_mode) {

    unsigned char nData, inData;
    BURST_INFO BurstInfo;
    DECLARE_1_ASP_ARGS;
#ifdef BURST_MODE
    if ( ApCmdGetProc(APCMD_GET_BURST_MODE, (char*)&BurstInfo) == STATUS_FAIL )
    {
        nData = 0;
    }
    else
    {
        nData = BurstInfo.BurstMode;
    }

    if ( strcmp(arg1, "disable") == 0 )
    {
        inData = 0;
    }
    else if ( strcmp(arg1, "enable") == 0 )
        inData = 1;

#endif	
    return websWrite(wp, T(nData==inData?"selected":""));
}

IMPLEMENT_ASP(asp_get_burst_rate) {

    unsigned char nData;
    BURST_INFO BurstInfo;
    DECLARE_0_ASP_ARGS;
#ifdef BURST_MODE
    if ( ApCmdGetProc(APCMD_GET_BURST_MODE, (char*)&BurstInfo) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }
    else
    {
        nData=BurstInfo.BurstRate;
    }
#endif
    return websWrite(wp, T("%d"), nData);   

}

IMPLEMENT_ASP(asp_get_G_Protection_mode) {

    unsigned short nData, inData;
    unsigned char nData1;
    DECLARE_1_ASP_ARGS;
    if ( ApCmdGetProc(APCMD_GET_FORCE_PROTECTION_MODE, (char*)&nData) == STATUS_FAIL )
    {
        nData = DATA_ERROR;
    }

#ifdef SELF_CTS
    if ( ApCmdGetProc(APCMD_GET_SELF_CTS, (char*)&nData1) == STATUS_FAIL )
    {
        nData1 = DATA_ERROR;
    }
    if (nData == 0xff) {
        nData = 1;
    }
    if( nData1 == 0 && nData == 0)
    {
        nData = 2; 
    }
#endif
    if ( strcmp(arg1, "onCTS") == 0 )
    {
        inData = 0;
    }
    else if ( strcmp(arg1, "off") == 0 )
    {
        inData = 1; 
    }
    else if ( strcmp(arg1, "onRTS") == 0 )
    {
        inData = 2; 
    }

    return websWrite(wp, T(nData==inData?"selected":""));

}

IMPLEMENT_ASP(asp_banner_create) {

    int sp = 0;
    DECLARE_1_ASP_ARGS;

    sp += websWrite(wp, T("<table border=\"1\" width=\"640\" bgcolor=\"#000000\" bordercolor=\"#C0C0C0\" cellspacing=\"0\"><tr>"));
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"association_tbl.asp\"><b><font color=\"#C0C0C0\">Association Table</font></b></a></td>"));
#ifdef AP_URPTR
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"radio_ur.asp\"><b><font color=\"#C0C0C0\">Radio</font></b></a></td>"));
#else
#if defined(FALCON) || defined(PEREGRINE)
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"radio_g.asp\"><b><font color=\"#C0C0C0\">Radio</font></b></a></td>"));
#else  
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"radio.asp\"><b><font color=\"#C0C0C0\">Radio</font></b></a></td>"));
#endif
#endif
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"wep.asp\"><b><font color=\"#C0C0C0\">Security</font></b></a></td>"));    
#ifndef SDRAM_4MB
#ifdef QOS_FEATURE
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"qos.asp\"><b><font color=\"#C0C0C0\">QoS</font></b></a></td>"));
#endif    
#endif
#if defined(GATEWAY)
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"LanIpConfig.asp\"><b><font color=\"#C0C0C0\">LAN IP</font></b></a></td>"));
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"WanIpConfig.asp\"><b><font color=\"#C0C0C0\">WAN IP</font></b></a></td>"));
#else
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"IpConfig.asp\"><b><font color=\"#C0C0C0\">IP</font></b></a></td>"));
#endif
#ifdef WDS_FEATURE
#if defined(AP_URPTR) 
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"wds.asp\"><b><font color=\"#C0C0C0\">WDS</font></b></a></td>"));
#endif
#endif
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"filter_list.asp\"><b><font color=\"#C0C0C0\">Filter</font></b></a></td>"));
#ifdef AP_SITE_SURVEY
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_survey.asp\"><b><font color=\"#C0C0C0\">Site Survey</font></b></a></td>"));
#endif    
#if defined(GATEWAY) || defined(DHCPS)
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"DhcpGlobal.asp\"><b><font color=\"#C0C0C0\">DHCP</font></b></a></td>"));    
#endif
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"fw_upgrade.asp\"><b><font color=\"#C0C0C0\">Firmware Upgrade</font></b></a></td>"));    
	#ifdef VOIP_GUI
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sip.asp\"><b><font color=\"#C0C0C0\">Voice</font></b></a></td>"));
	#endif
	#ifdef AUDIO_GUI
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"audio.asp\"><b><font color=\"#C0C0C0\">Audio Control</font></b></a></td>"));
	#endif
	#ifdef SLIC_GUI
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"slic.asp\"><b><font color=\"#C0C0C0\">Slic Control</font></b></a></td>"));
	#endif

    sp += websWrite(wp, T("</tr></table>"));

    return sp;
}
/* OPREGTEST */
IMPLEMENT_ASP(asp_banner_create_opreg) {

    int sp = 0;
    DECLARE_1_ASP_ARGS;

    sp += websWrite(wp, T("<table border=\"1\" width=\"640\" bgcolor=\"#000000\" bordercolor=\"#C0C0C0\" cellspacing=\"0\"><tr>"));
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"association_tbl.asp\"><b><font color=\"#C0C0C0\">Association Table</font></b></a></td>"));
#ifdef AP_URPTR
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"radio_ur.asp\"><b><font color=\"#C0C0C0\">Radio</font></b></a></td>"));
#else
#if defined(FALCON) || defined(PEREGRINE)
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"radio_g.asp\"><b><font color=\"#C0C0C0\">Radio</font></b></a></td>"));
#else  
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"radio.asp\"><b><font color=\"#C0C0C0\">Radio</font></b></a></td>"));
#endif
#endif
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"wep.asp\"><b><font color=\"#C0C0C0\">Security</font></b></a></td>"));    
#ifndef SDRAM_4MB
#ifdef QOS_FEATURE
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"qos.asp\"><b><font color=\"#C0C0C0\">QoS</font></b></a></td>"));
#endif    
#endif
#if defined(GATEWAY)
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"LanIpConfig.asp\"><b><font color=\"#C0C0C0\">LAN IP</font></b></a></td>"));
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"WanIpConfig.asp\"><b><font color=\"#C0C0C0\">WAN IP</font></b></a></td>"));
#else
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"IpConfig.asp\"><b><font color=\"#C0C0C0\">IP</font></b></a></td>"));
#endif
#ifdef WDS_FEATURE
#if defined(AP_URPTR) 
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"wds.asp\"><b><font color=\"#C0C0C0\">WDS</font></b></a></td>"));
#endif
#endif
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"filter_list.asp\"><b><font color=\"#C0C0C0\">Filter</font></b></a></td>"));
#ifdef AP_SITE_SURVEY
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"sys_survey.asp\"><b><font color=\"#C0C0C0\">Site Survey</font></b></a></td>"));
#endif    
#if defined(GATEWAY) && defined(DHCPS)
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"DhcpGlobal.asp\"><b><font color=\"#C0C0C0\">DHCP</font></b></a></td>"));    
#endif
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"fw_upgrade.asp\"><b><font color=\"#C0C0C0\">Firmware Upgrade</font></b></a></td>"));    
    sp += websWrite(wp, T("<td width=\"100\" align=\"center\"><a href=\"opreg.asp\"><b><font color=\"#C0C0C0\">Optimized Registers</font></b></a></td>"));    
    sp += websWrite(wp, T("</tr></table>"));

    return sp;
}

#if defined(AP_SITE_SURVEY) ||defined(DCS)
UINT32 stringToHtmlString(unsigned char *inBuf, 
                          int inBufLen,
                          unsigned char *outBuf, 
                          int outBufLen){
    unsigned char sLen, i, j;
    
    sLen = strlen(inBuf);
    if(sLen > inBufLen)
    {
        sLen = inBufLen;
    }
    for (i=0, j=0; i < sLen && j < outBufLen; i++)
    {
        if (*(inBuf+i)==0x22)
        {
            *(outBuf+j) = '&';
            j++;
            *(outBuf+j) = '#';
            j++;
            *(outBuf+j) = '3';
            j++;
            *(outBuf+j) = '4';
            j++;
            *(outBuf+j) = ';';
            j++;
        }
        else
        {
            *(outBuf+j) = *(inBuf+i);
            j++;
        }
    }
    return j;
}
#endif
#ifdef AP_SITE_SURVEY
IMPLEMENT_ASP(asp_get_site_survey) {

    int sp = 0;
    int i;
    unsigned char tmpBufSSID[100];
    APICMDBUF_GET_SURVEY_INFO getSurveyInfo;
    API_SURVEY_ENTRY *ssEntry_p;
    DECLARE_0_ASP_ARGS;

    if (ApCmdGetProc(APCMD_GET_SURVEY_INFO, (char*)&getSurveyInfo) == STATUS_FAIL)
    {
        return sp;
    }

    for (i=0; i < getSurveyInfo.maxEntry; i++)
    {
        ssEntry_p = getSurveyInfo.infoAddr + (i * sizeof(API_SURVEY_ENTRY));

        if (ssEntry_p->dirty)
        {
            memset(tmpBufSSID, 0, 33);
            stringToHtmlString(ssEntry_p->SsId, 32, &tmpBufSSID[0], 100);
#if 0
            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"><input type=\"radio\" name=\"peer\" value=\"%02x%02x%02x%02x%02x%02x\" ></td>\n"),
                            ssEntry_p->BssId[0], ssEntry_p->BssId[1], ssEntry_p->BssId[2], ssEntry_p->BssId[3], ssEntry_p->BssId[4], ssEntry_p->BssId[5]);
#else
#ifdef AP_URPTR
            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"><input type=\"radio\" name=\"peer\" value=\"%s\ %d\ %d\ %s\" ></td>\n"),
                            tmpBufSSID, ssEntry_p->channel, (ssEntry_p->IBSS?0:1), ssEntry_p->A_Support?"A":(ssEntry_p->G_Support?"G":"B"));
#else
            /* AP can't join any other AP */
            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"></td>\n"));
#endif

#endif
            sp += websWrite(wp, T("<td width=\"20\%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), tmpBufSSID);
            sp += websWrite(wp, T("<td width=\"20\%\" bgcolor=#ffff99><nobr>%02x-%02x-%02x-%02x-%02x-%02x</nobr></td>\n"),
                            ssEntry_p->BssId[0], ssEntry_p->BssId[1], ssEntry_p->BssId[2], ssEntry_p->BssId[3], ssEntry_p->BssId[4], ssEntry_p->BssId[5]);
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), ssEntry_p->channel);
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>%s</nobr></td>\n"), ssEntry_p->IBSS?"No":"Yes");
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), ssEntry_p->A_Support?"A":(ssEntry_p->G_Support?"G":"B"));

            if (ssEntry_p->wpaEnabled == 1)
            {
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA</nobr></td>\n"));
            }
			else if(ssEntry_p->wpaEnabled == 2)
			{
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2</nobr></td>\n"));
			}
            else
            {
                if (ssEntry_p->wepEnabled)
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WEP</nobr></td>\n"));
                }
                else
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>OPEN</nobr></td>\n"));
                }
            }
#ifdef WPA_INFO
            /* 1: WPA-PSK-TKIP  2: WPA-PSK-AES  3: WPA-1X-TKIP  4: WPA-1X-AES */
            /* 5: WPA2-PSK-TKIP 6: WPA2-PSK-AES 7: WPA2-1X-TKIP 8: WPA2-1X-AES */ 
            /* 9: WPA2-PSK-Mix  10: WPA2-1X-Mix */
            switch(ssEntry_p->wpaInfo){
                case 1:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA-PSK-TKIP</nobr></td>\n"));
                    break;
                case 2:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA-PSK-AES</nobr></td>\n"));
                    break;
                case 3:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA-1X-TKIP</nobr></td>\n"));
                    break;
                case 4:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA-1X-AES</nobr></td>\n"));
                    break;
                case 5:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2-PSK-TKIP</nobr></td>\n"));
                    break;
                case 6:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2-PSK-AES</nobr></td>\n"));
                    break;
                case 7:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2-1X-TKIP</nobr></td>\n"));
                    break;
                case 8:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2-1X-AES</nobr></td>\n"));
                    break;
                case 9:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2-PSK-Mix</nobr></td>\n"));
                    break;
                case 10:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2-1X-Mix</nobr></td>\n"));
                    break;
                default:
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>NONE</nobr></td>\n"));
                    
            }
#endif
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td></tr>\n"), ssEntry_p->RSSI);
        }
    }
    return sp;
}

#endif /* AP_SITE_SURVEY */

#ifndef SDRAM_4MB
#ifdef QOS_FEATURE
IMPLEMENT_ASP(asp_qos_mode) 
{
    UINT8 chInput = 0;
    APICMDBUF_GET_QOS_MODE qos_mode;
    DECLARE_1_ASP_ARGS;

    qos_mode.cmdCode = APCMD_GET_QOS_MODE;
    qos_mode.cmdBodyLen = sizeof(APICMDBUF_GET_QOS_MODE)-BUF_HDR_LEN;
    qos_mode.seqNum = 1;
    apctl(&qos_mode);

    if (strcmp(arg1, "Enabled") == 0)
    {
        chInput = 1;
    }
    else
        chInput = 0;

    return websWrite(wp, T(qos_mode.qos_mode == chInput?"selected":""));
}


IMPLEMENT_ASP(asp_noack_mode) 

{

    UINT8 chInput = 0;

    APICMDBUF_GET_NOACK_MODE noack_mode;

    DECLARE_1_ASP_ARGS;



    noack_mode.cmdCode = APCMD_GET_NOACK_MODE;

    noack_mode.cmdBodyLen = sizeof(APICMDBUF_GET_NOACK_MODE)-BUF_HDR_LEN;

    noack_mode.seqNum = 1;

    apctl(&noack_mode);



    if (strcmp(arg1, "Enabled") == 0)

    {

        chInput = 1;

    }

    else

        chInput = 0;



    return websWrite(wp, T(noack_mode.noack_mode == chInput?"selected":""));

}
IMPLEMENT_ASP(asp_qos_ts_list) 
{

    APICMDBUF_GET_QOS_TS_INFO ts_info;
    APICMDBUF_GET_QOS_MODE qos_mode;
    TSPECEntry_t *pInfo;
    UINT32 i;
    DECLARE_0_ASP_ARGS;

    qos_mode.cmdCode = APCMD_GET_QOS_MODE;
    qos_mode.cmdBodyLen = sizeof(APICMDBUF_GET_QOS_MODE)-BUF_HDR_LEN;
    qos_mode.seqNum = 1;
    apctl(&qos_mode);

    if (qos_mode.qos_mode)
    {
        // Get STA List 
        ts_info.cmdCode = APCMD_GET_QOS_TS;
        ts_info.cmdBodyLen = sizeof(APICMDBUF_GET_QOS_TS_INFO)-BUF_HDR_LEN;
        ts_info.seqNum = 1;
        apctl(&ts_info);

        pInfo = ts_info.pInfo;
        for (i=0; pInfo->not_free && (i < ts_info.maxEntry); i++)
        {

            websWrite(wp, T("<tr>\n"));
            //websWrite(wp, T("<td width=\"10%c\" align=\"center\">%d</td>\n"),0x25, nCnt++);
            websWrite(wp, T("<td width=\"5\%\" bgcolor=#ccffcc><input type=\"radio\" name=\"peer\" value=\"%02x-%02x-%02x-%02x-%02x-%02x-%d\"></td>\n"),
                      pInfo->src_addr[0],pInfo->src_addr[1],pInfo->src_addr[2],pInfo->src_addr[3],pInfo->src_addr[4],pInfo->src_addr[5],pInfo->TSpec.ts_info.tsid);
            websWrite(wp, T("<td width=\"45%\" bgcolor=#ccffcc><nobr>%02X:%02X:%02X:%02X:%02X:%02X</nobr></td>\n"), 
                      pInfo->src_addr[0],pInfo->src_addr[1],pInfo->src_addr[2],pInfo->src_addr[3],pInfo->src_addr[4],pInfo->src_addr[5]);

            if (pInfo->TSpec.ts_info.access_policy == 1)
                websWrite(wp, T("<td width=\"20%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), "EDCA");
            else if (pInfo->TSpec.ts_info.access_policy == 2)
                websWrite(wp, T("<td width=\"20%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), "HCCA");
            else if (pInfo->TSpec.ts_info.access_policy == 3)
                websWrite(wp, T("<td width=\"20%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), "Both");
            else
                websWrite(wp, T("<td width=\"20%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), "Rsvd");

            websWrite(wp, T("<td width=\"10%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), pInfo->TSpec.ts_info.tsid);

            if (pInfo->TSpec.ts_info.direction == 0)
                websWrite(wp, T("<td width=\"20%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), "Uplink");
            else if (pInfo->TSpec.ts_info.direction == 1)
                websWrite(wp, T("<td width=\"20%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), "Downlink");
            else if (pInfo->TSpec.ts_info.direction == 2)
                websWrite(wp, T("<td width=\"20%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), "Direct");
            else
                websWrite(wp, T("<td width=\"20%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), "BiDir");

            pInfo = ts_info.pInfo + ((i+1)*sizeof(TSPECEntry_t));
            //pInfo += sizeof(TSPECEntry_t);
        }
    }
    return 1;
}

IMPLEMENT_ASP(asp_wme_ac) {
    USHORT nData;

    nData=0;

    return websWrite(wp, T("%d"), nData);
}

IMPLEMENT_ASP(asp_wme_cwmin) {
    USHORT nData;


    APICMDBUF_GET_EDCA_PARAM Cmd;
    DECLARE_1_ASP_ARGS;

    Cmd.cmdCode = APCMD_GET_EDCA_PARAM;
    Cmd.cmdBodyLen = sizeof(APICMDBUF_GET_EDCA_PARAM)-BUF_HDR_LEN;
    Cmd.seqNum = 1;
     if (strcmp(arg1, "0") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
	 else if(strcmp(arg1, "1") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 1 ;
     else if(strcmp(arg1, "2") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 2 ;
     else if(strcmp(arg1, "3") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 3 ;
     else if (strcmp(arg1, "4") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 4 ;
	 else if(strcmp(arg1, "5") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 5 ;
     else if(strcmp(arg1, "6") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 6 ;
     else if(strcmp(arg1, "7") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 7 ;
     else
        Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;

    apctl(&Cmd);
    nData=Cmd.QAPEDCATable.QAPEDCATblCWmin;
    return websWrite(wp, T("%d"), nData);
}
IMPLEMENT_ASP(asp_wme_cwmax) {
    USHORT nData;

    APICMDBUF_GET_EDCA_PARAM Cmd;
    DECLARE_1_ASP_ARGS;

    Cmd.cmdCode = APCMD_GET_EDCA_PARAM;
    Cmd.cmdBodyLen = sizeof(APICMDBUF_GET_EDCA_PARAM)-BUF_HDR_LEN;
    Cmd.seqNum = 1;
	     if (strcmp(arg1, "0") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
	 else if(strcmp(arg1, "1") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 1 ;
     else if(strcmp(arg1, "2") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 2 ;
     else if(strcmp(arg1, "3") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 3 ;
     else if (strcmp(arg1, "4") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 4 ;
	 else if(strcmp(arg1, "5") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 5 ;
     else if(strcmp(arg1, "6") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 6 ;
     else if(strcmp(arg1, "7") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 7 ;
     else
        Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
    apctl(&Cmd);
    nData=Cmd.QAPEDCATable.QAPEDCATblCWmax;

    return websWrite(wp, T("%d"), nData);
}
IMPLEMENT_ASP(asp_wme_aifs) {
    USHORT nData;

      APICMDBUF_GET_EDCA_PARAM Cmd;
    DECLARE_1_ASP_ARGS;

    Cmd.cmdCode = APCMD_GET_EDCA_PARAM;
    Cmd.cmdBodyLen = sizeof(APICMDBUF_GET_EDCA_PARAM)-BUF_HDR_LEN;
    Cmd.seqNum = 1;
	     if (strcmp(arg1, "0") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
	 else if(strcmp(arg1, "1") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 1 ;
     else if(strcmp(arg1, "2") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 2 ;
     else if(strcmp(arg1, "3") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 3 ;
     else if (strcmp(arg1, "4") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 4 ;
	 else if(strcmp(arg1, "5") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 5 ;
     else if(strcmp(arg1, "6") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 6 ;
     else if(strcmp(arg1, "7") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 7 ;
     else
        Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
    apctl(&Cmd);
    nData=Cmd.QAPEDCATable.QAPEDCATblAIFSN;

    return websWrite(wp, T("%d"), nData);
}
IMPLEMENT_ASP(asp_wme_txoplimitB) {
    USHORT nData;

       APICMDBUF_GET_EDCA_PARAM Cmd;
    DECLARE_1_ASP_ARGS;

    Cmd.cmdCode = APCMD_GET_EDCA_PARAM;
    Cmd.cmdBodyLen = sizeof(APICMDBUF_GET_EDCA_PARAM)-BUF_HDR_LEN;
    Cmd.seqNum = 1;
	     if (strcmp(arg1, "0") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
	 else if(strcmp(arg1, "1") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 1 ;
     else if(strcmp(arg1, "2") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 2 ;
     else if(strcmp(arg1, "3") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 3 ;
     else if (strcmp(arg1, "4") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 4 ;
	 else if(strcmp(arg1, "5") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 5 ;
     else if(strcmp(arg1, "6") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 6 ;
     else if(strcmp(arg1, "7") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 7 ;
     else
        Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
    apctl(&Cmd);
    nData=Cmd.QAPEDCATable.QAPEDCATblTXOPLimitBAP * 32;

    return websWrite(wp, T("%d"), nData);
}
IMPLEMENT_ASP(asp_wme_txoplimit) {
    USHORT nData;

       APICMDBUF_GET_EDCA_PARAM Cmd;
    DECLARE_1_ASP_ARGS;

    Cmd.cmdCode = APCMD_GET_EDCA_PARAM;
    Cmd.cmdBodyLen = sizeof(APICMDBUF_GET_EDCA_PARAM)-BUF_HDR_LEN;
    Cmd.seqNum = 1;
	     if (strcmp(arg1, "0") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
	 else if(strcmp(arg1, "1") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 1 ;
     else if(strcmp(arg1, "2") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 2 ;
     else if(strcmp(arg1, "3") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 3 ;
     else if (strcmp(arg1, "4") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 4 ;
	 else if(strcmp(arg1, "5") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 5 ;
     else if(strcmp(arg1, "6") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 6 ;
     else if(strcmp(arg1, "7") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 7 ;
     else
        Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
    apctl(&Cmd);
    nData=Cmd.QAPEDCATable.QAPEDCATblTXOPLimit * 32;

    return websWrite(wp, T("%d"), nData);
}

IMPLEMENT_ASP(asp_wme_acm) {
    USHORT nData;

       APICMDBUF_GET_EDCA_PARAM Cmd;
    DECLARE_1_ASP_ARGS;

    Cmd.cmdCode = APCMD_GET_EDCA_PARAM;
    Cmd.cmdBodyLen = sizeof(APICMDBUF_GET_EDCA_PARAM)-BUF_HDR_LEN;
    Cmd.seqNum = 1;
	     if (strcmp(arg1, "0") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
	 else if(strcmp(arg1, "1") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 1 ;
     else if(strcmp(arg1, "2") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 2 ;
     else if(strcmp(arg1, "3") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 3 ;
     else if (strcmp(arg1, "4") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 4 ;
	 else if(strcmp(arg1, "5") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 5 ;
     else if(strcmp(arg1, "6") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 6 ;
     else if(strcmp(arg1, "7") == 0)
	    Cmd.QAPEDCATable.QAPEDCATblIndx = 7 ;
     else
        Cmd.QAPEDCATable.QAPEDCATblIndx = 0 ;
    apctl(&Cmd);
    nData=Cmd.QAPEDCATable.QAPEDCATblMandatory;

    return websWrite(wp, T("%d"), nData);
}


#endif
#endif
#if defined(GATEWAY) && defined(DHCPS)

IMPLEMENT_ASP(asp_dhcp_server_mode) {
    UCHAR pBuf[1360];
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_DHCPS_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
       memset(pBuf, 0, sizeof(pBuf));
    }

    return websWrite(wp, T((ULONG)(*(ULONG*)pBuf)?"checked":""));

}


IMPLEMENT_ASP(asp_ip_server_addr) {
    UCHAR pBuf[1360];
    int nFirst;
    DECLARE_2_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_DHCPS_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
        memset(pBuf, 0, sizeof(pBuf));
    }

    if ( strcmp(arg1, "sip") == 0 )
    {
        // "Start IP Address" starts from the 4th byte
        nFirst = 4;
    }
    else if ( strcmp(arg1, "eip") == 0 )
    {
        // "End IP Address" starts from the 8th byte
        nFirst = 8;
    }

    return websWrite(wp, T("%u"), pBuf[nFirst + atoi(arg2) - 1]);
}


IMPLEMENT_ASP(asp_global_lease_time) {
    UCHAR pBuf[1360];
    UCHAR leaseTimeValue[4];
    int nFirst = 12;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_DHCPS_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
        memset(pBuf, 0, sizeof(pBuf));
    }

    memcpy(leaseTimeValue,&pBuf[nFirst],4);

    return websWrite(wp, T("%lu"), (*(ULONG*)leaseTimeValue));
}
#endif

#if defined(GATEWAY) || defined(DHCPS)
IMPLEMENT_ASP(asp_dhcp_list) {
    USHORT  nCount=0;
    UCHAR pBuf[1360];
    UCHAR* pStations;
    UCHAR* currStation;
    UCHAR hostName[64]="";
    UCHAR expireTimeValue[4];
    UCHAR numberOfStations[4];
    USHORT  staticFlag=0;
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_DHCPS_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
         memset(pBuf, 0, sizeof(pBuf));
    }

/*    websWrite(wp, T("<tr>\n"));
    websWrite(wp, T("<td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"No");
    websWrite(wp, T("<td bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),"State");
    websWrite(wp, T("<td bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),"IP Address");
    websWrite(wp, T("<td bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),"MAC Address");
    websWrite(wp, T("<td bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),"Expire Time (Sec)");
    websWrite(wp, T("<td bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),"Host Name");
    websWrite(wp, T("</tr>\n"));
*/

    //copy to the numberOfStations parameters the current number of the defined stations
    memcpy(numberOfStations,&pBuf[16],4);

    // 20 is the size of all elements in APICMDBUF_GET_ETH_DHCPS_CONFIG declared before stationTbl
    pStations = &(pBuf[20]);

    for(nCount=0; nCount<*numberOfStations ;nCount++)
    {
		staticFlag = 0;
        currStation = pStations + nCount * sizeof(DHCPS_STATION_PROPERTIES);

        websWrite(wp, T("<tr>\n"));
        //Number of row
        //websWrite(wp, T("<td><a href=javascript:editEntry(%d)>%d</a></td>\n"), nCount+1,nCount+1);
        websWrite(wp, T("<td><a>%d</a></td>\n"), nCount+1);

        //Type of station
        websWrite(wp, T("<td>%s</td>\n"),
        (*currStation)==DHCPS_STATIC_ENTRY ? "Reserved":"Dynamic");
        if((*currStation)==DHCPS_STATIC_ENTRY)
            staticFlag=1;


        //IP address
        currStation = currStation + 4;
        websWrite(wp, T("<td>%d.%d.%d.%d</td>\n"),
        *currStation, *(currStation+1), *(currStation+2), *(currStation+3));

        //MAC adderss
        currStation = currStation + 4;
        websWrite(wp, T("<td>%02X:%02X:%02X:%02X:%02X:%02X</td>\n"),
        *currStation, *(currStation+1), *(currStation+2), *(currStation+3), *(currStation+4), *(currStation+5));

        //Expire time
        currStation = currStation + 8;
        memcpy(expireTimeValue,currStation,4);

        /*switch(*(ULONG*)expireTimeValue)
        {
            case 3600:
                    websWrite(wp, T("<td align=\"center\">1 Hour</td>\n"));
                    break;
            case 7200:
                    websWrite(wp, T("<td align=\"center\">2 Hours</td>\n"));
                    break;
            case 10800:
                    websWrite(wp, T("<td align=\"center\">3 Hours</td>\n"));
                    break;
            case 86400:
                    websWrite(wp, T("<td align=\"center\">1 Day</td>\n"));
                    break;
            case 172800:
                    websWrite(wp, T("<td align=\"center\">2 Days</td>\n"));
                    break;
            case 259200:
                    websWrite(wp, T("<td align=\"center\">3 Days</td>\n"));
                    break;
            case 604800:
                    websWrite(wp, T("<td align=\"center\">1 Week</td>\n"));
                    break;
            default:
                websWrite(wp, T("<td align=\"center\">&nbsp</td>\n"));
                break;
        }
        */

        if((staticFlag==1)||((staticFlag==0)&&((*(ULONG*)expireTimeValue)==0))){
            websWrite(wp, T("<td>&nbsp</td>\n"));
        }
        else{
            websWrite(wp, T("<td>%lu</td>\n"), (*(ULONG*)expireTimeValue));
        }

        //Host name
        currStation = currStation + 4;
        memcpy(hostName,currStation,64);
        if(!strcmp((UCHAR*)hostName,"")){
            websWrite(wp, T("<td>&nbsp</td>\n"));
        }
        else{
            websWrite(wp, T("<td>%s</td>\n"), hostName);
        }


        websWrite(wp, T("</tr>\n"));

    }
    return 1;
}

IMPLEMENT_ASP(asp_dhcp_global)
{
      UCHAR pBuf[1360];
      UCHAR leaseTimeValue[4];
      DECLARE_0_ASP_ARGS;



      if ( ApCmdGetProc(APCMD_GET_ETH_DHCPS_CONFIG, (char*)pBuf) == STATUS_FAIL )
      {
          memset(pBuf, 0, sizeof(pBuf));
      }

      websWrite(wp,T("<td colspan='5'>"));
      websWrite(wp,T("<input type='checkbox' name='DHCPServer'"));

      websWrite(wp, T((ULONG)(*(ULONG*)pBuf)?"checked":""));

      websWrite(wp, T("> Enable DHCP Server</td></tr><tr><td>Start IP Address</td>\n"));
      websWrite(wp, T("<td><input type='text' name='StartIPAddr1' value='"));
      websWrite(wp, T("%u"), pBuf[4]);  // "Start IP Address" starts from the 4th byte
      websWrite(wp,T("' maxlength=3 size='3'><b>.</td>\n"));

      websWrite(wp, T("<td><input type='text' name='StartIPAddr2' value='"));
      websWrite(wp, T("%u"), pBuf[5]);  // "SIP Address" from the 5th byte
      websWrite(wp,T("' maxlength=3 size='3'><b>.</td>\n"));

      websWrite(wp, T("<td><input type='text' name='StartIPAddr3' value='"));
      websWrite(wp, T("%u"), pBuf[6]);  // "SIP Address" from the 6th byte
      websWrite(wp,T("' maxlength=3 size='3'><b>.</td>\n"));

      websWrite(wp, T("<td><input type='text' name='StartIPAddr4' value='"));
      websWrite(wp, T("%u"), pBuf[7]);  // "SIP Address" from the 7th byte
      websWrite(wp,T("' maxlength=3 size='3'><b></td></tr>\n"));


      // "End IP Address" starts from the 8th byte
      websWrite(wp,T("<tr><td>End IP Address</td><td><input type='text' name='EndIPAddr1' value='"));
      websWrite(wp, T("%u"), pBuf[8]);
      websWrite(wp, T("' maxlength=3 size='3'><b>.</td>\n"));

      websWrite(wp, T("<td><input type='text' name='EndIPAddr2' value='\n"));
      websWrite(wp, T("%u"), pBuf[9]);
      websWrite(wp, T("' maxlength=3 size='3'><b>.</td>\n"));

      websWrite(wp, T("<td><input type='text' name='EndIPAddr3' value='\n"));
      websWrite(wp, T("%u"), pBuf[10]);
      websWrite(wp, T("' maxlength=3 size='3'><b>.</td>\n"));

      websWrite(wp, T("<td><input type='text' name='EndIPAddr4' value='\n"));
      websWrite(wp, T("%u"), pBuf[11]);
      websWrite(wp, T("' maxlength=3 size='3'><b></td></tr>\n"));

      // Lease time starts in 12th byte

      websWrite(wp, T(" <tr> <td>Lease Time</td><td colspan=4><select name='GlobalLeaseTime'>\n"));
      websWrite(wp, T("<option value=3600>1 Hour</option>\n"));
      websWrite(wp, T("<option value=7200>2 Hours</option>\n"));
      websWrite(wp, T("<option value=10800>3 Hours</option>\n"));
      websWrite(wp, T("<option value=86400>1 Day</option>\n"));
      websWrite(wp, T("<option value=172800>2 Days</option>\n"));
      websWrite(wp, T("<option value=259200>3 Days</option>\n"));
      websWrite(wp, T("<option value=604800>1 Week</option>\n"));
      websWrite(wp, T("</select><script> document.forms[0].GlobalLeaseTime.value ="));


      memcpy(leaseTimeValue,&pBuf[12],4);
      websWrite(wp, T("%lu"), (*(ULONG*)leaseTimeValue));

      websWrite(wp, T("</script></td>\n"));
      return 1;
}
#endif

#if defined(GATEWAY) || defined(DHCPS)
IMPLEMENT_ASP(asp_lan_ip_config)
{
    UCHAR pBuf[8];
    DECLARE_0_ASP_ARGS;

    if ( ApCmdGetProc(APCMD_GET_ETH_LAN_IP_CONFIG, (char*)pBuf) == STATUS_FAIL )
    {
        memset(pBuf, 0, sizeof(pBuf));
    }

    websWrite(wp,T("<tr>\n"));
    websWrite(wp,T("<td>IP Address</td>\n"));
    websWrite(wp,T("<td>\n"));
    websWrite(wp,T("<p align='left'>\n"));
    websWrite(wp,T("<input type='text' name='IPAddr1' value='"));
    websWrite(wp,T("%u"), pBuf[0]);
    websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
    websWrite(wp,T("</td>\n"));
    websWrite(wp,T("<td>\n"));
    websWrite(wp,T("<p align='left'>\n"));
    websWrite(wp,T("<input type='text' name='IPAddr2' value='"));
    websWrite(wp,T("%u"), pBuf[1]);
    websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
    websWrite(wp,T("</td>\n"));
    websWrite(wp,T("<td>\n"));
    websWrite(wp,T("<p align='left'>\n"));
    websWrite(wp,T("<input type='text' name='IPAddr3' value='"));
    websWrite(wp,T("%u"), pBuf[2]);
    websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
    websWrite(wp,T("</td>\n"));
    websWrite(wp,T("<td>\n"));
    websWrite(wp,T("<p align='left'>\n"));
    websWrite(wp,T("<input type='text' name='IPAddr4' value='"));
    websWrite(wp,T("%u"), pBuf[3]);
    websWrite(wp,T("'  maxlength=3 size='3'>\n"));
    websWrite(wp,T("</td>\n"));
    websWrite(wp,T("</tr>\n"));
    websWrite(wp,T("<tr>\n"));

    websWrite(wp,T("<td>IP Mask</td>\n"));
    websWrite(wp,T("<td>\n"));
    websWrite(wp,T("<p align='left'>\n"));
    websWrite(wp,T("<input type='text' name='Mask1' value='"));
    websWrite(wp,T("%u"), pBuf[4]);
    websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
    websWrite(wp,T("</td>\n"));
    websWrite(wp,T("<td>\n"));
    websWrite(wp,T("<p align='left'>\n"));
    websWrite(wp,T("<input type='text' name='Mask2' value='"));
    websWrite(wp,T("%u"), pBuf[5]);
    websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
    websWrite(wp,T("</td>\n"));
    websWrite(wp,T("<td>\n"));
    websWrite(wp,T("<p align='left'>\n"));
    websWrite(wp,T("<input type='text' name='Mask3' value='"));
    websWrite(wp,T("%u"), pBuf[6]);
    websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
    websWrite(wp,T("</td>\n"));
    websWrite(wp,T("<td>\n"));
    websWrite(wp,T("<p align='left'>\n"));
    websWrite(wp,T("<input type='text' name='Mask4' value='"));
    websWrite(wp,T("%u"), pBuf[7]);
    websWrite(wp,T("' maxlength=3 size='3'>\n"));
    websWrite(wp,T("</td>\n"));
    websWrite(wp,T("</tr>\n"));

    return 1;
}


#if defined(GATEWAY)
IMPLEMENT_ASP(asp_wan_ip_config)
{
      UCHAR pBuf[24];
      DECLARE_0_ASP_ARGS;

      if ( ApCmdGetProc(APCMD_GET_ETH_WAN_IP_CONFIG, (char*)pBuf) == STATUS_FAIL )
      {
          memset(pBuf, 0, sizeof(pBuf));
      }

      websWrite(wp,T("<tr>\n"));
      websWrite(wp,T("<td colspan='5'>\n"));
      websWrite(wp,T("<input type='radio' name='DHCP' value='1' \n"));
      websWrite(wp, T((ULONG)(*(ULONG*)pBuf)?"checked":""));
      websWrite(wp,T(">Enable DHCP</td>\n"));
      websWrite(wp,T("</tr>\n"));
      websWrite(wp,T("<tr>\n"));
      websWrite(wp,T("<td colspan='5'>\n"));
      websWrite(wp,T("<input type='radio' name='DHCP' value='0' \n"));
      websWrite(wp, T((ULONG)(*(ULONG*)pBuf)?"":"checked"));
      websWrite(wp,T(">Use the following IP address: </td>\n"));
      websWrite(wp,T("</tr>\n"));

      websWrite(wp,T("<tr>\n"));
      websWrite(wp,T("<td>IP Address</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='IPAddr1' value='"));
      websWrite(wp,T("%u"), pBuf[4]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='IPAddr2' value='"));
      websWrite(wp,T("%u"), pBuf[5]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='IPAddr3' value='"));
      websWrite(wp,T("%u"), pBuf[6]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='IPAddr4' value='"));
      websWrite(wp,T("%u"), pBuf[7]);
      websWrite(wp,T("'  maxlength=3 size='3'>\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("</tr>\n"));
      websWrite(wp,T("<tr>\n"));

      websWrite(wp,T("<td>IP Mask</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='Mask1' value='"));
      websWrite(wp,T("%u"), pBuf[8]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='Mask2' value='"));
      websWrite(wp,T("%u"), pBuf[9]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='Mask3' value='"));
      websWrite(wp,T("%u"), pBuf[10]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='Mask4' value='"));
      websWrite(wp,T("%u"), pBuf[11]);
      websWrite(wp,T("' maxlength=3 size='3'>\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("</tr>\n"));

      websWrite(wp,T("<tr>\n"));
      websWrite(wp,T("<td>Default Gateway</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='Gateway1' value='"));
      websWrite(wp,T("%u"), pBuf[12]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='Gateway2' value='"));
      websWrite(wp,T("%u"), pBuf[13]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='Gateway3' value='"));
      websWrite(wp,T("%u"), pBuf[14]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='Gateway4' value='"));
      websWrite(wp,T("%u"), pBuf[15]);
      websWrite(wp,T("' maxlength=3 size='3'>\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("</tr>\n"));

      websWrite(wp,T("<tr>\n"));
      websWrite(wp,T("<td>Primary DNS</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='PDNS1' value='"));
      websWrite(wp,T("%u"), pBuf[16]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='PDNS2' value='"));
      websWrite(wp,T("%u"), pBuf[17]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='PDNS3' value='"));
      websWrite(wp,T("%u"), pBuf[18]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='PDNS4' value='"));
      websWrite(wp,T("%u"), pBuf[19]);
      websWrite(wp,T("' maxlength=3 size='3'>\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("</tr>\n"));

      websWrite(wp,T("<tr>\n"));
      websWrite(wp,T("<td>Secondary DNS</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='SDNS1' value='"));
      websWrite(wp,T("%u"), pBuf[20]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='SDNS2' value='"));
      websWrite(wp,T("%u"), pBuf[21]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='SDNS3' value='"));
      websWrite(wp,T("%u"), pBuf[22]);
      websWrite(wp,T("' maxlength=3 size='3'><b>.\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("<td>\n"));
      websWrite(wp,T("<p align='left'>\n"));
      websWrite(wp,T("<input type='text' name='SDNS4' value='"));
      websWrite(wp,T("%u"), pBuf[23]);
      websWrite(wp,T("' maxlength=3 size='3'>\n"));
      websWrite(wp,T("</td>\n"));
      websWrite(wp,T("</tr>\n"));

      return 1;
}
#endif
#endif
#ifdef FLEXMODE_TEST
IMPLEMENT_ASP(asp_get_nav_offset_value){
    DECLARE_0_ASP_ARGS;
    
    //return websWrite(wp, T("%d"), NavOffset);
    return websWrite(wp, T("%d"), AGintOffset);
}
IMPLEMENT_ASP(asp_get_flex_mode_beacon){
    DECLARE_0_ASP_ARGS;
    
    //return websWrite(wp, T("%d"), FlexModeBeacon);
    return websWrite(wp, T("%d"), AGinterval);
}
#endif /* FLEXMODE_TEST */
#ifdef IEEE80211H
IMPLEMENT_ASP(asp_get_SPECTRUM_MGMT_value)
{
    UCHAR cData;
    DECLARE_0_ASP_ARGS;
    
    if ( ApCmdGetProc(APCMD_GET_SPECTRUM_MGMT, &cData) == STATUS_FAIL )
    {
        return websWrite(wp, T("%d"), DATA_ERROR);
    }

	
    return websWrite(wp, T("%d"), cData);
    

}
IMPLEMENT_ASP(asp_get_MITIGATION_value){
    ULONG nData;
    DECLARE_0_ASP_ARGS;
    
    if ( ApCmdGetProc(APCMD_GET_MITIGATION, (char*)&nData) == STATUS_FAIL )
    {
        return websWrite(wp, T("%d"), DATA_ERROR);
    }
    return websWrite(wp, T("%d"), nData);
}
IMPLEMENT_ASP(asp_get_CHANNEL_ANNOUNCEMENT_value)
{
    DECLARE_0_ASP_ARGS;
    
    if(gSwitchChannel==0 || gSwitchChannel==36)
        return websWrite(wp, T("0"));
    else if (gSwitchChannel==40)
        return websWrite(wp, T("1"));
    else if (gSwitchChannel==44)
        return websWrite(wp, T("2"));
    else if (gSwitchChannel==48)
        return websWrite(wp, T("3"));
    else if (gSwitchChannel==52)
        return websWrite(wp, T("4"));
    else if (gSwitchChannel==56)
        return websWrite(wp, T("5"));
    else if (gSwitchChannel==60)
        return websWrite(wp, T("6"));
    else if (gSwitchChannel==64)
        return websWrite(wp, T("7"));
    else if (gSwitchChannel==149)
        return websWrite(wp, T("8"));
    else if (gSwitchChannel==153)
        return websWrite(wp, T("9"));
    else if (gSwitchChannel==157)
        return websWrite(wp, T("10"));
    else if (gSwitchChannel==161)
        return websWrite(wp, T("11"));
    else if (gSwitchChannel==165)
        return websWrite(wp, T("12"));
}
IMPLEMENT_ASP(asp_get_REGULATORY_DOMAIN_value)
{
    DECLARE_0_ASP_ARGS;
    
    if(bcn_reg_domain == DOMAIN_CODE_FCC )
        return websWrite(wp, T("0"));
    else if (bcn_reg_domain == DOMAIN_CODE_IC)
        return websWrite(wp, T("1"));
    else if (bcn_reg_domain == DOMAIN_CODE_ETSI)
        return websWrite(wp, T("2"));
    else if (bcn_reg_domain == DOMAIN_CODE_SPAIN)
        return websWrite(wp, T("3"));
    else if (bcn_reg_domain == DOMAIN_CODE_FRANCE)
        return websWrite(wp, T("4"));
    else if (bcn_reg_domain == DOMAIN_CODE_MKK)
        return websWrite(wp, T("5"));    
    else
        return websWrite(wp, T("6"));
        
}
#endif


IMPLEMENT_ASP(asp_WDS_Bssid){
    APICMDBUF_GET_UREPEATER cmdBuf;
    UCHAR   *pChar, i;
    DECLARE_0_ASP_ARGS;

    cmdBuf.cmdCode = APCMD_GET_UREPEATER;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_UREPEATER)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
#ifdef AP_URPTR
    apctl(&cmdBuf);
#else
    for (i = 0; i<6; i++) cmdBuf.urBssid[i] = 0;
#endif
    pChar = (UCHAR *) &cmdBuf.urBssid;
    //return websWrite(wp, T("%s"), cmdBuf.urBssid);
    return websWrite(wp, T("%02X:%02X:%02X:%02X:%02X:%02X"),
                  *pChar, *(pChar+1), *(pChar+2), *(pChar+3), *(pChar+4), *(pChar+5));
    
}

IMPLEMENT_ASP(asp_WDS_ConnBssid){
    APICMDBUF_GET_UREPEATER_LINK cmdBuf;
    UCHAR   *pChar, i;
    DECLARE_0_ASP_ARGS;

    cmdBuf.cmdCode = APCMD_GET_UREPEATER_LINK;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_UREPEATER_LINK)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
#ifdef AP_URPTR
    apctl(&cmdBuf);
#else
    for (i = 0; i<6; i++) cmdBuf.urBssid[i] = 0;
#endif
    pChar = (UCHAR *) &cmdBuf.urBssid;
    //return websWrite(wp, T("%s"), cmdBuf.urBssid);
    return websWrite(wp, T("%02X:%02X:%02X:%02X:%02X:%02X"),
                  *pChar, *(pChar+1), *(pChar+2), *(pChar+3), *(pChar+4), *(pChar+5));
    
}


IMPLEMENT_ASP(asp_WDS_ssid){
    APICMDBUF_GET_UREPEATER cmdBuf;
    UCHAR i;
    DECLARE_0_ASP_ARGS;
    
    cmdBuf.cmdCode = APCMD_GET_UREPEATER;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_UREPEATER)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
#ifdef AP_URPTR
    apctl(&cmdBuf);
#else
    util_CopyList(cmdBuf.urSsid, OEM_UR_SSID, IEEEtypes_SSID_SIZE); 
#endif
    return websWrite(wp, T("%s"), cmdBuf.urSsid);
}

IMPLEMENT_ASP(asp_UR_mode) {
    char chData, inData, mode;
    APICMDBUF_GET_UREPEATER cmdBuf; 
    DECLARE_1_ASP_ARGS;;
    cmdBuf.cmdCode = APCMD_GET_UREPEATER;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_UREPEATER)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    cmdBuf.urMode = 0;
    cmdBuf.wbMode = 0;
    mode = 0;
#ifdef AP_URPTR
    apctl(&cmdBuf);
	if (strcmp(arg1, "UR Mode") == 0) 
    {
		inData = 1;
	}
    else if (strcmp(arg1, "WB Mode") == 0)
    {
        inData = 2;
    }
    else
		inData = 0;
#else
    inData = 0;
#endif

    if ((cmdBuf.urMode == 1) &&
        (cmdBuf.wbMode == 1))
    {
        mode = 2;
    }
    else if ((cmdBuf.urMode == 1) &&
             (cmdBuf.wbMode == 0))
    {
        mode = 1;
    }
    else
        mode = 0;

	return websWrite(wp, T(mode==inData?"selected":""));
}


IMPLEMENT_ASP(asp_WDS_PrefBssid) {
    char chData, inData;
    APICMDBUF_GET_UREPEATER cmdBuf; 
    DECLARE_1_ASP_ARGS;;
    cmdBuf.cmdCode = APCMD_GET_UREPEATER;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_UREPEATER)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
#ifdef AP_URPTR
    apctl(&cmdBuf);
	if (strcmp(arg1, "Enabled") == 0) 
    {
		inData = 1;
	} 
    else
		inData = 0;
#else
    inData = 0;
#endif

	return websWrite(wp, T(cmdBuf.urPrefBssid==inData?"selected":""));
}

IMPLEMENT_ASP(asp_urLinkStatus){
    APICMDBUF_GET_UREPEATER_LINK cmdBuf; 
    DECLARE_0_ASP_ARGS;

    cmdBuf.cmdCode = APCMD_GET_UREPEATER_LINK;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_UREPEATER_LINK)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    apctl(&cmdBuf);
    
    if(cmdBuf.urLink == UR_CONNECTED)
        return websWrite(wp, T("1"));
    else
        return websWrite(wp, T("0"));
}

/* OPREGTEST */
static UINT8 regBBP[]= 	 {0x01, 0x02, 0x07, 0x17, 0x1B, 0x1D, 0x1E, 0x1F, 
					  	  0x27, 0x28, 0x29, 0x2B, 0x2C, 0x2F, 0x30, 0x31,
					  	  0x34, 0x35, 0x37, 0x38, 0x3F, 0x40, 0x41, 0x42,
					  	  0x45, 0x4B, 0x4C, 0x4D, 0x4F, 0x50, 0x51, 0x52,
					      0x55, 0x56, 0x57, 0x82, 0x83, 0x87, 0x88, 0x8A,
					  	  0xA4, 0xB8, 0xBF, 0xCB, 0xCE, 0xD6, 0xDE, 0xE4, 
					  	  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
#ifdef HARRIER	/* W8030 */
static UINT8 regRF[] = {0x00, 0x01, 0x06, 0x09, 0x0C, 0x0F, 0x10, 0x12, 
				  	    0x13, 0x14, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D,
				        0x1E, 0x1F, 0x20, 0x23, 0x30, 0x3E, 0x42, 0x49,
				        0x4F, 0x50, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
#else  /* W8010 */
static UINT8 regRF[] = {0x00, 0x01, 0x02, 0x06, 0x07, 0x08, 0x09, 0x0B, 
						0x0C, 0x0D, 0x0E, 0x13, 0x14, 0x18, 0x19, 0x1A, 
						0x1B, 0x1C, 0x1D, 0x1E, 0x1F, 0x20, 0x23, 0x30, 
						0x39, 0x3A, 0x3B, 0x3C, 0x48, 0x49, 0xFF, 0xFF};
#endif
static UINT32 regMAC[] = {0x80002018, 0x80002048, 0x8000A240, 0x8000A244, 
						  0x8000A824, 0x8000A58C, 0x8000A660, 0x8000A2D0,
						  0xFFFFFFFF, 0xFFFFFFFF};

IMPLEMENT_ASP(asp_regBBP_list) {
	UINT8 i, j;
	UINT8 regvale = 0;

    websWrite(wp, T("  <tr>\n"));
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("  </tr>\n"));

	i = 0;
	W81_BBPInitAccess();
	while(regBBP[i] != 0xFF)
	{
		j=0;
		websWrite(wp, T("  <tr>\n"));
		while((regBBP[i+j] != 0xFF) && (j<4))
		{
	    	regvale = 0;
	    	if (regBBP[i+j] >= 0x80)
				msi_wl_WriteBBP(0, 0x80);
			else
				msi_wl_WriteBBP(0, 0x00);
					
	    	msi_wl_ReadBBP(regBBP[i+j], &regvale);
	        
	        websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">0x%02X</td>\n"),0x25, regBBP[i+j]);                     
	        websWrite(wp, T("    <td width=\"5%c\" align=\"center\">0x%02X</td>\n"),0x25, regvale);
			
			j ++;
		}
		websWrite(wp, T("  </tr>\n"));
		if (j<4)
			break;
		i += j;
	}
	msi_wl_WriteBBP(0, 0x00);

    return 1;
}

IMPLEMENT_ASP(asp_regRF_list) {
	UINT8 i, j;
	UINT8 regvale = 0;

    websWrite(wp, T("  <tr>\n"));
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"5%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("  </tr>\n"));

	i = 0;
	sys_InitPHYAccess();
	while(regRF[i] != 0xFF)
	{
		j=0;
		websWrite(wp, T("  <tr>\n"));
		while((regRF[i+j] != 0xFF) && (j<4))
		{
	    	regvale = 0;
	    	msi_wl_ReadPHY(regRF[i+j], &regvale);
	        
	        websWrite(wp, T("    <td width=\"5%c\" bgcolor=\"#9999FF\" align=\"center\">0x%02X</td>\n"),0x25, regRF[i+j]);                     
	        websWrite(wp, T("    <td width=\"5%c\" align=\"center\">0x%02X</td>\n"),0x25, regvale);
			
			j ++;
		}
		websWrite(wp, T("  </tr>\n"));
		if (j<4)
			break;
		i += j;
	}
	 
    return 1;
}

IMPLEMENT_ASP(asp_regMAC_list) {
	UINT8 i, j;
	UINT32 regvale = 0;

    websWrite(wp, T("  <tr>\n"));
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">%s</td>\n"),0x25,"Address");
    websWrite(wp, T("    <td width=\"10%c\" align=\"center\">%s</td>\n"),0x25,"Value");
    websWrite(wp, T("  </tr>\n"));

	i = 0;
	while(regMAC[i] != 0xFFFFFFFF)
	{
		j=0;
		websWrite(wp, T("  <tr>\n"));
		while((regMAC[i+j] != 0xFFFFFFFF) && (j<2))
		{
	    	regvale = 0;
	    	regvale = *((UINT32 *)regMAC[i+j]);
	        
	        websWrite(wp, T("    <td width=\"10%c\" bgcolor=\"#9999FF\" align=\"center\">0x%08X</td>\n"),0x25, regMAC[i+j]);                     
	        websWrite(wp, T("    <td width=\"10%c\" align=\"center\">0x%08X</td>\n"),0x25, regvale);
			
			j ++;
		}
		websWrite(wp, T("  </tr>\n"));
		if (j<2)
			break;
		i += j;
	}
	 
    return 1;
}
/* AutoLink ASP */
IMPLEMENT_ASP(asp_wpa_passphrase) {
#ifdef AUTOLINK
    APICMDBUF_GET_PSK_PASSPHRASE cmdBuf;
    APICMDBUF_GET_AL_ENABLE_STATE cmdBuf1;
    DECLARE_1_ASP_ARGS;
    cmdBuf.cmdCode = APCMD_GET_PSK_PASSPHRASE;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_PSK_PASSPHRASE)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    apctl(&cmdBuf);

    cmdBuf1.cmdCode = APCMD_GET_AL_ENABLE_STATE;
    cmdBuf1.cmdBodyLen = sizeof(APICMDBUF_GET_AL_ENABLE_STATE)- 4*sizeof(unsigned short);
    cmdBuf1.seqNum = 1;
    apctl(&cmdBuf1);

    if (WpaEnabled && cmdBuf1.ALEnable)
        return websWrite(wp,T("%s"),cmdBuf.passphrase);
    else 
        return websWrite(wp, T("**********"));
#else
        return websWrite(wp, T("**********"));
#endif
}

IMPLEMENT_ASP(asp_al_low_power) {
#ifdef AUTOLINK
    APICMDBUF_GET_AL_LOW_POWER_STATE cmdBuf;
    DECLARE_0_ASP_ARGS;
    cmdBuf.cmdCode = APCMD_GET_AL_LOW_POWER_STATE;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_AL_LOW_POWER_STATE)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    apctl(&cmdBuf);

    return websWrite(wp, T(cmdBuf.ALLowTxPowerEnable?"checked":"")); 
#else
    return websWrite(wp, T(FALSE?"checked":"")); 
#endif
}

IMPLEMENT_ASP(asp_al_enable) {
#ifdef AUTOLINK
    APICMDBUF_GET_AL_ENABLE_STATE cmdBuf;
    DECLARE_0_ASP_ARGS;

    cmdBuf.cmdCode = APCMD_GET_AL_ENABLE_STATE;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_AL_ENABLE_STATE)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    apctl(&cmdBuf);

    return websWrite(wp, T(cmdBuf.ALEnable?"checked":"")); 
#else
    return websWrite(wp, T(FALSE?"checked":"")); 
#endif
}

IMPLEMENT_ASP(asp_al_sec_mode) {
#ifdef AUTOLINK
    unsigned int inData;
    APICMDBUF_GET_AL_SEC_MODE cmdBuf;
    DECLARE_1_ASP_ARGS;
    cmdBuf.cmdCode = APCMD_GET_AL_SEC_MODE;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_AL_SEC_MODE)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    apctl(&cmdBuf);

    if (strcmp(arg1, "WPA-TKIP") == 0) {
        inData = 1;
    } else if (strcmp(arg1, "WPA2-AES") == 0) {
        inData = 5;
    }

    return websWrite(wp, T(cmdBuf.ALSecmode == inData?"selected":""));
#else
    return websWrite(wp, T(FALSE?"selected":""));
#endif
}

IMPLEMENT_ASP(asp_al_on_time) {
#ifdef AUTOLINK
    unsigned int inData;
    APICMDBUF_GET_AL_ON_TIME cmdBuf;
    DECLARE_1_ASP_ARGS;
    cmdBuf.cmdCode = APCMD_GET_AL_ON_TIME;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_AL_ON_TIME)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    apctl(&cmdBuf);

    if (strcmp(arg1, "1") == 0) {
        inData = 20;
    } else if (strcmp(arg1, "2") == 0) {
        inData = 40;
    } else if (strcmp(arg1, "3") == 0) {
        inData = 60;
    } else if (strcmp(arg1, "4") == 0) {
        inData = 120;
    }

    return websWrite(wp, T(cmdBuf.ALONTime == inData?"selected":""));
#else
    return websWrite(wp, T(FALSE?"selected":""));
#endif
}

IMPLEMENT_ASP(asp_al_pp_enable) {
#ifdef AUTOLINK
    APICMDBUF_GET_AL_PP_ENABLE_STATE cmdBuf;
    DECLARE_0_ASP_ARGS;
    cmdBuf.cmdCode = APCMD_GET_AL_PP_ENABLE_STATE;
    cmdBuf.cmdBodyLen = sizeof(APICMDBUF_GET_AL_PP_ENABLE_STATE)- 4*sizeof(unsigned short);
    cmdBuf.seqNum = 1;
    apctl(&cmdBuf);

    return websWrite(wp, T(cmdBuf.ALPPEnable?"checked":"")); 
#else
    return websWrite(wp, T(FALSE?"checked":"")); 
#endif
}


IMPLEMENT_ASP(asp_dcsmode) {
    char chData, inData;
	DECLARE_1_ASP_ARGS;
#ifdef DCS
    if ( ApCmdGetProc(APCMD_GET_DCS_MODE, &chData)==STATUS_FAIL )
    {
		chData = (char)DATA_ERROR;
    }
#else
    chData = 0;
#endif
	if (strcmp(arg1, "enableverysensitive") == 0) {
		inData = 3;
	} else if (strcmp(arg1, "enablesensitive") == 0) {
		inData = 2;
	} else if (strcmp(arg1, "enabledefault") == 0) {
		inData = 1;
	} else if (strcmp(arg1, "disable") == 0) {
		inData = 0;
	}

	return websWrite(wp, T(chData==inData?"selected":""));
}

IMPLEMENT_ASP(asp_dcsmodestatus) {
    char chData;
	DECLARE_1_ASP_ARGS;
#ifdef DCS
    if ( ApCmdGetProc(APCMD_GET_DCS_MODE, &chData)==STATUS_FAIL )
    {
		chData = (char)DATA_ERROR;
    }
	return websWrite(wp, T((chData != 0)?"checked":""));
#else
	return websWrite(wp, T("disabled"));
#endif
}

IMPLEMENT_ASP(asp_get_bss_bgscan) {
    int sp = 0;
#ifdef DCS
    int i;
    unsigned char tmpBufSSID[100];
    APICMDBUF_GET_BGSCAN_DATA getBGscanInfo;
    API_BGSCAN_BSS_ENTRY *ssEntry_p;
    DECLARE_0_ASP_ARGS;

    if (ApCmdGetProc(APCMD_GET_BGSCAN_DATA, (char*)&getBGscanInfo) == STATUS_FAIL)
    {
        return sp;
    }

    for (i=0; i < getBGscanInfo.maxEntry; i++)
    {
        ssEntry_p = getBGscanInfo.BSSInfoAddr + (i * sizeof(API_BGSCAN_BSS_ENTRY));

        if (ssEntry_p->dirty)
        {
            memset(tmpBufSSID, 0, 33);
            stringToHtmlString(ssEntry_p->Ssid, 32, &tmpBufSSID[0], 100);
#if 0
            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"><input type=\"radio\" name=\"peer\" value=\"%02x%02x%02x%02x%02x%02x\" ></td>\n"),
                            ssEntry_p->BssId[0], ssEntry_p->BssId[1], ssEntry_p->BssId[2], ssEntry_p->BssId[3], ssEntry_p->BssId[4], ssEntry_p->BssId[5]);
#else
//            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"><input type=\"radio\" name=\"peer\" value=\"%s\ %d\ %d\ %s\" ></td>\n"),
//                            tmpBufSSID, ssEntry_p->channel, (ssEntry_p->IBSS?0:1), ssEntry_p->A_Support?"A":(ssEntry_p->G_Support?"G":"B"));
#endif

            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), ssEntry_p->channel);
            sp += websWrite(wp, T("<td width=\"20\%\" bgcolor=#ffff99><nobr>%02x-%02x-%02x-%02x-%02x-%02x</nobr></td>\n"),
                            ssEntry_p->Bssid[0], ssEntry_p->Bssid[1], ssEntry_p->Bssid[2], ssEntry_p->Bssid[3], ssEntry_p->Bssid[4], ssEntry_p->Bssid[5]);
            sp += websWrite(wp, T("<td width=\"20\%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), tmpBufSSID);

//            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>%s</nobr></td>\n"), ssEntry_p->IBSS?"No":"Yes");
//            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), ssEntry_p->A_Support?"A":(ssEntry_p->G_Support?"G":"B"));

#if 0
            if (ssEntry_p->wpaEnabled == 1)
            {
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA</nobr></td>\n"));
            }
			else if(ssEntry_p->wpaEnabled == 2)
			{
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2</nobr></td>\n"));
			}
            else
            {
                if (ssEntry_p->wepEnabled)
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WEP</nobr></td>\n"));
                }
                else
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>OPEN</nobr></td>\n"));
                }
            }
#endif
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td></tr>\n"), ssEntry_p->RSSI);
        }
    }
#endif /* DCS */
    return sp;
}

IMPLEMENT_ASP(asp_get_ch_bgscan) {
    int sp = 0;
#ifdef DCS
    int i;
//    unsigned char tmpBufSSID[100];
    unsigned short nData;
    APICMDBUF_GET_BGSCAN_DATA getBGscanInfo;
    APICMDBUF_GET_CHWGT_DATA getCHWgtInfo;
    API_BGSCAN_CH_ENTRY *ssEntry_p;
    API_CH_WEIGHT_ENTRY *entry_p;
    
    DECLARE_0_ASP_ARGS;

    if (ApCmdGetProc(APCMD_GET_BGSCAN_DATA, (char*)&getBGscanInfo) == STATUS_FAIL)
    {
        return sp;
    }

    if (ApCmdGetProc(APCMD_GET_CHWEIGHT_DATA, (char*)&getCHWgtInfo) == STATUS_FAIL)
    {
        return sp;
    }

    for (i=1; i <(IEEEtypes_MAX_CHANNELS+IEEEtypes_MAX_CHANNELS_A); i++)
    {
        ssEntry_p = getBGscanInfo.CHInfoAddr + (i * sizeof(API_BGSCAN_CH_ENTRY));
        entry_p = getCHWgtInfo.CHWgtInfoAddr + (i * sizeof(API_CH_WEIGHT_ENTRY));

        if (ssEntry_p->dirty)
        {
//            memset(tmpBufSSID, 0, 33);
//            stringToHtmlString(ssEntry_p->Ssid, 32, &tmpBufSSID[0], 100);
#if 0
            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"><input type=\"radio\" name=\"peer\" value=\"%02x%02x%02x%02x%02x%02x\" ></td>\n"),
                            ssEntry_p->BssId[0], ssEntry_p->BssId[1], ssEntry_p->BssId[2], ssEntry_p->BssId[3], ssEntry_p->BssId[4], ssEntry_p->BssId[5]);
#else
//            sp += websWrite(wp, T("<tr><td width=\"5\%\" bgcolor=\"#ffff99\"><input type=\"radio\" name=\"peer\" value=\"%s\ %d\ %d\ %s\" ></td>\n"),
//                            tmpBufSSID, ssEntry_p->channel, (ssEntry_p->IBSS?0:1), ssEntry_p->A_Support?"A":(ssEntry_p->G_Support?"G":"B"));
#endif

            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), ssEntry_p->channel);
//            sp += websWrite(wp, T("<td width=\"20\%\" bgcolor=#ffff99><nobr>%02x-%02x-%02x-%02x-%02x-%02x</nobr></td>\n"),
//                            ssEntry_p->Bssid[0], ssEntry_p->Bssid[1], ssEntry_p->Bssid[2], ssEntry_p->Bssid[3], ssEntry_p->Bssid[4], ssEntry_p->Bssid[5]);
//            sp += websWrite(wp, T("<td width=\"20\%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), tmpBufSSID);

//            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>%s</nobr></td>\n"), ssEntry_p->IBSS?"No":"Yes");
//            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%s</nobr></td>\n"), ssEntry_p->A_Support?"A":(ssEntry_p->G_Support?"G":"B"));

#if 0
            if (ssEntry_p->wpaEnabled == 1)
            {
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA</nobr></td>\n"));
            }
			else if(ssEntry_p->wpaEnabled == 2)
			{
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WPA2</nobr></td>\n"));
			}
            else
            {
                if (ssEntry_p->wepEnabled)
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>WEP</nobr></td>\n"));
                }
                else
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ffff99><nobr>OPEN</nobr></td>\n"));
                }
            }
#endif
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), ssEntry_p->bytesRecd);
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), ssEntry_p->errorBytesRecd);

            if (ApCmdGetProc(APCMD_GET_RF_CHANNEL, (char*)&nData) == STATUS_SUCCESS)
            {
#ifdef AUTOCHANNEL
                if (nData & 0x8000 )
                {
                    nData = 0;
                }
                else
                {
            		nData &=0x7fff;
                }
#endif
                if (ssEntry_p->channel == nData)
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), getBGscanInfo.curCHTxCount);
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), getBGscanInfo.curCHTxRetryCnt);
                }
                else
                {
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), 0);
                    sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), 0);
                }
            }
            else
            {
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), 0);
                sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), 0);
            }
            
            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td>\n"), ssEntry_p->NoiseFloor);

            sp += websWrite(wp, T("<td width=\"10\%\" bgcolor=#ccffcc><nobr>%d</nobr></td></tr>\n"), entry_p->CHWeight);
        }
    }
#endif /* DCS */
    return sp;
}
#ifdef VOIP_GUI
IMPLEMENT_ASP(asp_get_voip_cfg) {
	unsigned char buf1[100];
	unsigned char buf2[100];
	unsigned short port, start, stop;
	hs_voip_codec_t  preferred;

	websWrite(wp, T("<script language=JavaScript type=text/javascript>\n"));

	hs_voip_cm_get_endpoint_user_map(0, buf1);
	sprintf(buf2, "var handsetId = '%s';\n", buf1);
	websWrite(wp, T(buf2));

	hs_voip_cm_get_endpoint_device_name(0, buf1);
	sprintf(buf2, "var handsetName = '%s';\n", buf1);
	websWrite(wp, T(buf2));

	hs_voip_cm_get_sip_proxy(buf1, &port); 
	sprintf(buf2, "var proxyOption = %d;\n"
				  "var proxyIp = '%s';\n"
				  "var proxyPort = %u;\n", 
				  strlen(buf1)?0:1, buf1, port);
	websWrite(wp, T(buf2));

	hs_voip_cm_get_user_name(buf1);
	sprintf(buf2, "var proxyUsername = '%s';\n", buf1);
	websWrite(wp, T(buf2));

	hs_voip_cm_get_sip_password(buf1);
	sprintf(buf2, "var proxyPassword = '%s';\n", buf1);
	websWrite(wp, T(buf2));

	hs_voip_cm_get_sip_registrar(buf1, &port);
	sprintf(buf2, "var registrarOption = %d;\n"
				  "var registrarIp = '%s';\n"
				  "var registrarPort = %u;\n", 
				  strlen(buf1)?0:1, buf1, port);
	websWrite(wp, T(buf2));

	if ( hs_voip_cm_params_g.usable_codec_list_len > 0 )
		preferred = hs_voip_cm_params_g.usable_codec_list[0];
	else
		preferred = HS_VOIP_CODEC_PCMA;
	switch (preferred)
	{
	case HS_VOIP_CODEC_PCMA:
		preferred = 0;
		break;
	case HS_VOIP_CODEC_PCMU:
		preferred = 1;
		break;
	case HS_VOIP_CODEC_G723:
	    if (hs_voip_cm_params_g.codec_rate == 1)
			preferred = 2;
		else
			preferred = 3;
		break;
	case HS_VOIP_CODEC_G729A:
		preferred = 4;
		break;
	case HS_VOIP_CODEC_G726_16:
		preferred = 5;
		break;
	case HS_VOIP_CODEC_G726_24:
		preferred = 6;
		break;
	case HS_VOIP_CODEC_G726_32:
		preferred = 7;
		break;
	case HS_VOIP_CODEC_G726_40:
		preferred = 8;
		break;
	default:
        preferred = 1;
	}
	sprintf(buf2, "var preferredEnc = %d;\n", preferred);
	websWrite(wp, T(buf2));

	sprintf(buf2, "var dtmfOption = %d;\n", hs_voip_cm_get_support_2833_flag()?0:1);
	websWrite(wp, T(buf2));

	sprintf(buf2, "var vadOption = %d;\n", hs_voip_cm_get_endpoint_vad_flag(0)?0:1);
	websWrite(wp, T(buf2));

	hs_voip_cm_get_rtp_port_limits(&start, &stop);
	sprintf(buf2, "var rtpStart = %d;\n"
				  "var rtpStop = %d;\n", 
				  start, stop);
	websWrite(wp, T(buf2));

	return websWrite(wp, T("</script>\n"));
}
#endif // VOIP_GUI

IMPLEMENT_ASP(asp_guestaccess_enable) {
#ifdef GUEST_ACCESS
    APICMDBUF_GET_GUEST_ACCESS getbuf;
    DECLARE_0_ASP_ARGS;

    if(webApiCmd(APCMD_GET_GUEST_ACCESS, &getbuf, sizeof(APICMDBUF_GET_GUEST_ACCESS)-BUF_HDR_LEN) == 0)
        return websWrite(wp, T("%d"), getbuf.GuestAccessEnable);
    else
#endif
        return websWrite(wp, T("0"));
}

IMPLEMENT_ASP(asp_guestaccess_passphrase) {
#ifdef GUEST_ACCESS
    APICMDBUF_GET_GUEST_ACCESS getbuf;
    DECLARE_0_ASP_ARGS;

    if(webApiCmd(APCMD_GET_GUEST_ACCESS, &getbuf, sizeof(APICMDBUF_GET_GUEST_ACCESS)-BUF_HDR_LEN) == 0)
        return websWrite(wp, T("%s"), getbuf.GuestAccessPassPhrase);
    else
#endif
        return websWrite(wp, T(""));
}

IMPLEMENT_ASP(asp_guestaccess_passphrase2) {
#ifdef GUEST_ACCESS
    APICMDBUF_GET_GUEST_ACCESS getbuf;
    DECLARE_0_ASP_ARGS;

    if(webApiCmd(APCMD_GET_GUEST_ACCESS, &getbuf, sizeof(APICMDBUF_GET_GUEST_ACCESS)-BUF_HDR_LEN) == 0)
        return websWrite(wp, T("%s"), getbuf.GuestAccessPassPhrase2);
    else
#endif
        return websWrite(wp, T(""));
}
