#include "wltypes.h"
#include "IEEE_types.h"
#include "os_if.h"
#include "oem.h"

extern int webmain(void);
static void WebTask(os_Addrword_t Data);

static cyg_thread Task;
static cyg_handle_t TaskHdl;
#define sysinfo_WEB_TASK_NAME          "Web"
#define sysinfo_WEB_TASK               8
#define sysinfo_WEB_TASK_STACK_SIZE    (16*1024)
#define sysinfo_WEB_TASK_PRI           14

static UINT8 WebStack[sysinfo_WEB_TASK_STACK_SIZE] __attribute__ ((aligned (4)));

Status_e web_Init(void)
{
    cyg_thread_create(sysinfo_WEB_TASK_PRI,
                      WebTask,
                      0,
                      sysinfo_WEB_TASK_NAME,
                      (void *)(WebStack),
                      sysinfo_WEB_TASK_STACK_SIZE,
                      &TaskHdl,
                      &Task);
    return (SUCCESS);
}

void web_Start(void)
{
    cyg_thread_resume(TaskHdl);
}

static void WebTask(os_Addrword_t Data)
{
    webmain();
}
