
/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
 * 
 * oem.h
 * 
 * Purpose:  Common Configuration Files
 * 
 * Public Procedures: 
 * 
 * Notes: 
 *    None. 
 * 
 *****************************************************************************/
#ifndef __OEM_H__
#define __OEM_H__
#include "buildmodes.h"
#define AP22N
//#define AP32GST

/* Do not define, the code is not stable when enable D_CACHE */
#ifdef AP32GST
#define D_CACHE
#define NO_GUI
#endif

#ifndef AP22N
#define AP22c
#endif

//AP22N or AP32GST must define NEW_VLAN_CONFIG
#ifdef AP22N
#define NEW_VLAN_CONFIG
//#define NO_VLAN 1
#endif

#ifdef NEW_VLAN_CONFIG
#define WAN_PORT 4
#else
#define WAN_PORT 0
#endif

//#define DMZ_CONFIG
#ifdef DMZ_CONFIG
#define DMZ_PORT 4
#endif

/* Only needed for AP22C */
#ifdef AP22c
#define AP22C_RX_ETHER_POOL_SIZE 280
#define CLK_ADJ_SUPPORT 1
#endif

#define NEW_FLEXMODE


#endif //END OEM_H
