#ifndef _WPA_H_
#define _WPA_H_
typedef enum
{
    KEYMGMT_ERROR,
    KEYMGMTTIMEOUTEVENT, //key management timeout
    GRPKEYTIMEOUTEVENT
}keymgmt_timout_msg_type_e;

//Rahul
typedef struct
{
    //timer_Data_t timerData;
    //uint32   Id;
    IEEEtypes_MacAddr_t StnAddr;
    keymgmt_timout_msg_type_e type;
}
dist_PendingData_t;

/*----------------*/
/* Timer Messages */
/*----------------*/

typedef struct
{
    dist_PendingData_t PendingData_p;
    UINT8 Id;
}
distQ_TimerMsg_t;

typedef enum{
    WPAEVT_STA_AUTHENTICATED,
    WPAEVT_STA_ASSOCIATED,
    WPAEVT_STA_DEAUTHENTICATED,
    WPAEVT_STA_DISASSOCIATED,
    WPAEVT_STA_AUTHENTICATE_FAIL,
}WPA_ASSOC_TYPE;

typedef struct _StaAssocStateMsg
{
    unsigned char staMACAddr[6];
    WPA_ASSOC_TYPE assocType;
}
StaAssocStateMsg_t;

typedef enum
{
    STA_ASSOMSGRECVD,
    TIMERMSGRECVD,
    KEYMGMTINITMSGRECVD
#ifdef AUTOLINK
	,AUTOLINKBUTTONPRESSED
#endif
}MsgType_e;

typedef struct
{
    MsgType_e MsgType;
    union
    {
        StaAssocStateMsg_t StaAssocStateMsg;
        distQ_TimerMsg_t distQ_TimerMsg;
    }msg;
}
DistTaskMsg_t;

#endif
