/******************* (c) Marvell Semiconductor, Inc., 2001 ********************
 *
 *  $Header: //depot/MRVL/main/firmware/AP5x/OS/ecos131/install/gateway_install/include/src/w81_eth.h#1 $
 *
 *  Purpose:
 *     This file contains the register definitions for the eagle ethernet hardware
 *
 *  Public Procedures:
 *     None.
 *
 *  Private Procedures:
 *     None.
 *
 *  Notes:
 *     None.
 *
 *****************************************************************************/
#ifndef _W81_ETH_H_
#define _W81_ETH_H_

typedef struct {
        unsigned int key;
        unsigned int totalLen;
#ifdef GATEWAY
        unsigned int interface;/*0 - LAN ;1 - WAN*/
#endif
        unsigned char data[1600];
} dsQ_LlcData_t;


extern void w8100_eth_TxEvent(dsQ_LlcData_t *pkt);
extern int dsQ_LlcDataWriteNoBlock(dsQ_LlcData_t *LlcData_p );
extern dsQ_LlcData_t *ds_GetLlcDataBuf(void);
struct eth_drv_sc *sc1;
extern unsigned char *rcvdData;
#ifdef GATEWAY
struct eth_drv_sc *sc0;
extern unsigned int rcvdPort;
#endif
#endif   /* _W81_ETH_H_ */
