.equ I_Cache_Enable,	(1 << 12)
.equ D_Cache_Enable,	(1 << 2)
	.text
	.globl	disable_cache
disable_cache:
	mrc	p15, 0, r3, c1, c0, 0
	ldr	r0,=(I_Cache_Enable | D_Cache_Enable)
	bic	r3,r3,r0
	mcr	p15, 0, r3, c1, c0, 0
	bx	r14
	.globl	enable_cache
enable_cache:
	mrc	p15, 0, r3, c1, c0, 0
	ldr	r0,=(I_Cache_Enable | D_Cache_Enable)
	orr	r3,r3,r0
	mcr	p15, 0, r3, c1, c0, 0
	bx	r14
	.globl	invalidate_cache
invalidate_cache:
	mov	r3,#0
	mcr	p15, 0, r3, c7, c5, 0   @ flush I-cache
	mcr	p15, 0, r3, c7, c6, 0   @ flush D-cache
	bx	r14

	.globl	disable_data_cache
disable_data_cache:
	mrc	p15, 0, r3, c1, c0, 0
	ldr	r0,=(D_Cache_Enable)
	bic	r3,r3,r0
	mcr	p15, 0, r3, c1, c0, 0
	bx	r14
	.globl	enable_data_cache
enable_data_cache:
	mrc	p15, 0, r3, c1, c0, 0
	ldr	r0,=(D_Cache_Enable)
	orr	r3,r3,r0
	mcr	p15, 0, r3, c1, c0, 0
	bx	r14
	.globl	invalidate_data_cache
invalidate_data_cache:
	mov	r3,#0
	mcr	p15, 0, r3, c7, c6, 0   @ flush D-cache
	bx	r14		
	