#define  IDLE            0x00
#define  PROG            0x01
#define  PROGERR         0x02
#define  COM_SEQ_ERR     0x05
#define  SEQ_NUM_ERR     0x06
#define  PROG_ERR        0x07
#define  VERIFY_ERR      0x09

#define  GET_VERSION_INFO 0x0000
#define  DOWN_REQUEST     0x0001
#define  DOWN_DATA        0x0002
#define  DOWN_RESET       0x0003
#define  DOWN_VERIFY      0x0004   //!!! 09/30/96 Add a new download comd
#define  DOWN_ERASE_ALL   0x0005
#define  DOWN_REPLY       0x0006   //    11/21/2001 Add a new download command

#define  WRITE_EALL     1
#define  WRITE_UPGRADE  2
#define  ERASE_EALL	3
#define  ERASE_UPGRADE	4
#define  ERASE_VERIFY   5

#define FLASH_ADRS	0xFFF00000
#define PID_OFFSET           (0x100000 - 0x46)
#define PRODUCT_ID_OFFSET     0x0DFFF0
#define PROTOCOL_ID_OFFSET   (PRODUCT_ID_OFFSET + 0x02)
#define FW_VERSION_OFFSET    (PRODUCT_ID_OFFSET + 0x04)
#define DOMAIN_ADDRESS			0x0FFF60

#define  VCI_LEN         56

typedef struct  VCI  {
//    unsigned char    Prifix[7];
    unsigned short    VerControl;
    unsigned short    DownControl;
    unsigned char    Hid[32];
    unsigned short    Hver;
    unsigned short    ProdID;
    unsigned short    ProdIDmask;
    unsigned short    ProtID;
    unsigned short    ProtIDmask;
    unsigned short    FuncID;
    unsigned short    FuncIDmask;
    unsigned short    Fver;
    unsigned short    Cseg;
    unsigned short    Csize;
//    unsigned char    Postfix[7];
}VCI_TABLE;
// __attribute__((packed))  VCI_TABLE;


typedef struct {
   unsigned char    DestAddress[6];
   unsigned char    SrcAddress[6];
   unsigned short   sap;
   unsigned short   wcmd;
   unsigned short   wsequence;
   unsigned short   woffset;
   unsigned short   wsegment;
   unsigned short   wLen;
   unsigned char    bData[600];
}DLC;
// __attribute__((packed));

typedef  struct  DCB_TYPE {
    unsigned short   sequn;
    unsigned short   dest_seg;
    unsigned short   dest_off;
    unsigned short   src_seg;
    unsigned short   src_off;
    unsigned short   count;
    unsigned         erase;
    unsigned         no;
    unsigned short  tme_of_day;
    ULONG   state;
}   DCB_BUF;


unsigned short LToLs(unsigned short dwData)
{
   return dwData;
}

unsigned short xchg ( unsigned short dwData)
{
   unsigned short temp;
   temp = ((dwData & 0xff) << 8);
   temp |= ((dwData & 0xff00) >> 8);
   return temp;

}