#ifndef _APFLASH_H_

#define _APFLASH_H_ 

/*******************************************************************

*

*    DESCRIPTION: Interface for AP flash module

*

*    AUTHOR: cvu@marvell.com

*

*    HISTORY:

*    12dec02,cvu,created

*

*

*******************************************************************/



extern void flashDrvInit(void);

extern int ResetToFactorySettings(void);

extern int GetUserConfig(void);

extern int SetUserConfig(void);

extern int FirmwareUpgrade(char *, unsigned long);

extern int SaveUserConfig(void);

extern int UserConfigModified(void);



#endif /* _APFLASH_H_ */

