/*
** main.c
** 
** Program to set board up.
** 
*/
/*----- Types and Constants Definition ----------------------*/
#define _REG(x) (*(volatile unsigned long *)(x))
#define _REG16(x) (*(volatile unsigned short *)(x))

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "board.h"

/* This array indexed by enum BOARD_TYPE */
const char *board_names[]={
    "Original evaluation board", 
    "AP21 board with 2x1Mx16 SDRAM", 
    "AP21 board with 1x2Mx32 SDRAM", 
    "AP21 board with 1x4Mx16 SDRAM", 
    "AP22 board with 2x4Mx16 SDRAM", 
    "AP22 board with 1x2Mx32 SDRAM",
    "AP32 board with 2x4Mx16 SDRAM"
};


int main()
{
   printf("Config MDU for %s\n", board_names[BOARD_DEF]);
   ConfigMDU(BOARD_DEF);
   printf("Done\n");
}

