#ifndef list_h
#define list_h

#include "Cplus.h"

typedef struct ListItem
{
    struct ListItem *nxt;
    struct ListItem *prv;
}ListItem;


CLASS(List)
    ListItem *head;
    ListItem *tail;
    unsigned int cnt;
METHODS
    void ListInit(List *me);
    ListItem *ListGetItem(List *me);
    void ListPutItem(List *me, ListItem *Item);
    ListItem *ListDelItem(List *me, ListItem *Item);
END_CLASS

#endif
