/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
 * 
 * Purpose: 
 * 
 * Public Procedures: 
 * 
 * Notes: 
 *    None. 
 * 
 *****************************************************************************/

#ifndef _BCNGEN_H_
#define _BCNGEN_H_

#include "wlmac.h"
#include "macmgmtap.h"

#define SETBIT    1
#define RESETBIT  0
#define SET_ERP_PROTECTION 1
#define RESET_ERP_PROTECTION 0

extern macmgmtQ_MgmtMsg_t * BcnBuffer_p;
extern WL_STATUS bcngen_Init(void);
extern void bcngen_Start(void);
extern void bcngen_UpdateBeaconBuffer(IEEEtypes_StartCmd_t *StartCmd_p);
extern void bcngen_UpdateBitInTim(UINT16 Aid, BOOLEAN Set);
extern void bcngen_BeaconFreeIsr(void);
extern void bcngen_UpdateBeaconErpInfo(BOOLEAN SetFlag);
extern void bcngen_EnableBcnFreeIntr(void);
extern void bcngen_UpdateBeaconBuffer2(IEEEtypes_StartCmd_t *StartCmd);


#ifdef WPA 
// Add RSN IE to a frame body
UINT16 AddRSN_IE(IEEEtypes_RSN_IE_t* pNextElement);
#endif

#ifdef IEEE80211H
void bcngen_AddChannelSwithcAnnouncement_IE(IEEEtypes_ChannelSwitchAnnouncementElement_t *pChannelSwitchAnnouncementIE);
void bcngen_RemoveChannelSwithcAnnouncement_IE(void);
void bcngen_AddQuiet_IE(IEEEtypes_QuietElement_t *pQuietIE);
void bcngen_RemoveQuiet_IE(void);
#endif /* IEEE80211H */

#ifdef UR_WPA
void InitThisStaRsnIEUr();
#endif

#endif /* _BCNGEN_H_ */
