#ifndef _POOL_IF_H_
#define _POOL_IF_H_

/******************************************************************************
 * Name: pool_FreeBuf
 *
 * Description:
 *    Return a buffer to the pool.
 *
 * Conditions for Use:
 *    The pool module has been initialized, the pool created, and the buffer
 *    has been allocated.
 *
 * Arguments:
 *    Arg1 (i  ): ReturnedBuf_p - Pointer to the buffer being returned
 *
 * Return Value:
 *    None.
 *
 * Notes:
 *    None.
 *
 *****************************************************************************/
extern WL_STATUS pool_FreeBuf ( char* ReturnedBuf_p );
#endif
